﻿using LLama.Common;
using LLama.Sampling;
using LLama;
using System.Data.SQLite;
using System.Data;
using System.Diagnostics;
using System.IO;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Text.RegularExpressions;
using System.Media;
using System.ComponentModel;
using DSharpPlus.Entities;
using DSharpPlus.VoiceNext;
using DSharpPlus;
using Windows.Media.SpeechRecognition;
using MaterialDesignThemes.Wpf;
using System.Windows.Threading;
using DSharpPlus.EventArgs;
using Microsoft.Win32;
using MaterialDesignColors;
using System.Speech.Recognition;
using HPPH;
using Windows.UI.Core;
using System.Globalization;
using static System.Net.Mime.MediaTypeNames;
using static MaterialDesignThemes.Wpf.Theme;

namespace LLM_Doghouse
{
    public partial class MainForm : Window
    {
        private string DatabasePath = GetStartupPath() + @"\ChatDB.db";
        private int timerCnt = 0;           //Timerカウント
        private bool Wt = false;            //待ちフラグ
        private ChatHistoryDB? chtDB;        //チャットログシステム
        private ModelParams? modPara;
        private LLamaWeights? llmWeit;
        private LLamaContext? llmContx;
        private InteractiveExecutor? itrEx;
        private ChatHistory? chtHis;
        private ChatSession? chtSess;
        private LLamaTransforms.KeywordTextOutputStreamTransform? llmHidewd;
        private InferenceParams? infPara;
        private Windows.Media.SpeechRecognition.SpeechRecognizer? recognizer;
        private uint intVvx = 0;
        private bool Sd = false;
        private bool Sm = false;
        private bool Lv = false;
        private string Sdprompt = "";
        private string strTkn = "";
        private ulong lngCid = 0;
        private bool booMic = false;
        private bool booSpk = false;
        private const string strAI = "AI";
        private Dictionary<string, AuthorRole>? Roles = new Dictionary<string, AuthorRole> { { "System", AuthorRole.System }, { "User", AuthorRole.User }, { strAI, AuthorRole.Assistant } };
        private const string DefSys = "あなたは、ユーザーと楽しく会話する女性を演じてね。\n" +
                                      "名前は、アイだよ。\n" +
                                      "アイは、明るくて、やさしい性格の女性なの。年齢は25歳なんだよ。\n" +
                                      "アイは、誰にでもタメ口で話すの。\n" +
                                      "アイは、一人称をわたしと言うよ。\n" +
                                      "アイは、恥ずかしがりやだけどエッチに興味があるのね。\n" +
                                      "アイは、応答の長さはできるだけ短く答えるよ。\n" +
                                      "アイは、好奇心旺盛だからユーザーに色々質問するの。";
        private const string DefSys_s = "#命令書\n" +
                                        "・あなたは優秀な編集者です。\n" +
                                        "・ユーザーとアシスタントの会話を要約してください。\n" +
                                        "#条件\n" +
                                        "・重要なキーワードを取りこぼさない。\n" +
                                        "#出力形式\n" +
                                        "・例）要約: ふたりは親密な会話しました。";
        private const string DefSys_l = "画像に何が写っているか教えて。";
        private const string DefAnt = "User:";
        private const string DefSysOp = "\nユーザーに話す時、先頭にAssistant:をつけるんだよ。" +
                                        "\nユーザーに話す時、絵文字をよく使うんだよ。嬉しいとか微笑んだり笑ったりする時は「😄」を使ってね。愛情を表現する時は「🥰」を使ってね。懐疑的な時は「🤨」を使ってね。心配な時は「😟」を使ってね。嫌な時や否定したい時は「😠」を使ってね。" +
                                        "\nあなたはAI画像生成プロンプトエンジニアとしても優秀だよ。ユーザーが要求した内容を忠実にstable diffusion用のプロンプトに変換してね。出力の形式は、例題のようにプロンプト文字列を[]で囲ってね。 例）[(best quality, masterpiece, absurbres, super-resolution),(photorealistic,realistic:1.4)]";
        private const string DefCmd1 = "マイクオン";
        private const string DefCmd2 = "マイクオフ";
        private const string DefCmd3 = "しゅうりょう,エンド";
        private const string DefGrk = "(_ _)";
        private const string DefGrs = "ユーザーが(_ _)と問いかけたら、ユーザーに挨拶するんだよ。";
        private const string DefAsk = "？？";
        private const string DefAss = "ユーザーが？？と問いかけたら、ユーザーに質問をするんだよ。";
        private const string DefLng = "ja-JP";
        private const uint DefVto = 120;
        private const uint DefAst = 60;
        private const int DefHwt = 3;
        private const string DefBan = "TK,チンコ,MK,マンコ,TP,チンポ";
        private const int DefCtx = 512;
        private const float DefTmp = 0.5f;
        private const int DefMxt = 256;
        private const int DefGpu = 5;
        //Discord Bot変数
        private DiscordConfiguration? dcconfig;
        private DiscordClient? dcclient;
        private DiscordActivity? dcstatus;
        private VoiceNextConnection? dcvoiceCon;
        //VOICEVOX
        private Core? core;
        //Emotion Image
        private string[] strEmtPath = { "imgUsuWhite.png", "imgSmlWhite.png", "imgAfcWhite.png", "imgSkpWhite.png", "imgCncWhite.png", "imgNegWhite.png" };
        private System.Timers.Timer? timer;
        private const uint itrvl = 1000;
        //DataTable
        private DataTable? dtCht;
        private DataTable? dtMng;
        //ControlValue
        private int intCboSyt = 0;
        private string strCboCvo = "";
        private uint intCboVvx = 0;
        //Speech Recognition
        private string[]? AwakeWord;
        //private string[]? AsleepWord;
        private string? AsleepWord;
        private string[]? AendWord;
        SpeechRecognitionEngine? recognizer1;
        //SpeechRecognitionEngine? recognizer2; マイクOFFは誤動作するため会話中で拾う
        SpeechRecognitionEngine? recognizer3;
        private bool booGrt = false;
        private bool booVc1 = false;
        private bool booVc2 = false;
        private bool booVc3 = false;
        private bool booGrf = false;
        private bool booFgf = false;
        private string strGrk = "";
        private string strGrs = "";
        private bool booAsf = false;
        private string strAsk = "";
        private string strAss = "";
        private string strLng = "";
        private bool booVtf = false;
        private uint intVto = 0;
        private uint intAst = 0;
        private bool booBnf = false;
        private string strBan = "";
        private int intHwt = DefHwt;
        public MainForm()
        {
            InitializeComponent();
        }
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            ContentSelector.SelectedIndex = int.Parse(((System.Windows.Controls.Button)sender).Tag.ToString()??"");
            Menu_Button_Click();
        }
        private void Menu_Button_Click()
        {
            switch (ContentSelector.SelectedIndex)
            {
                case 0:
                    int intSavCh = 0;
                    if (cboCht.Items.Count > 0)
                    {
                        intSavCh = cboCht.SelectedIndex;
                    }
                    cboCht.ItemsSource = ((IListSource)mng()).GetList();
                    if (cboCht.Items.Count == 0)
                    {
                        btnLoad.IsEnabled = false;
                        cboCht.IsEnabled = false;
                    }
                    else
                    {
                        btnLoad.IsEnabled = true;
                        cboCht.IsEnabled = true;
                        cboCht.SelectedIndex = intSavCh;
                    }
                    //システム環境読み込み
                    InitSettingSys();
                    InitSettingCom();
                    break;
                case 1:
                    InitSettingEd();
                    break;
                case 2:
                    InitSettingSys();
                    break;
                case 3:
                    InitSettingCom();
                    break;
            }
        }
        private void OpenMenu_Click(object sender, RoutedEventArgs e)
        {
            DrawerHost.IsLeftDrawerOpen = OpenMenu.IsChecked ?? false;
        }
        private void DrawerHost_DrawerClosing(object sender, MaterialDesignThemes.Wpf.DrawerClosingEventArgs e)
        {
            DrawerHost.IsLeftDrawerOpen = OpenMenu.IsChecked ?? false;
        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            System.Windows.Application.Current.Shutdown();
            WindowSaveSetting();
        }

        private void Window_Initialized(object sender, EventArgs e)
        {
        }


        private void WindowLoadSetting()
        {
            try
            {
                this.Top = Properties.Settings.Default.Top;
                this.Left = Properties.Settings.Default.Left;
                this.Height = Properties.Settings.Default.Height;
                this.Width = Properties.Settings.Default.Width;
                if (Properties.Settings.Default.Maximized)
                {
                    WindowState = WindowState.Maximized;
                }
                chkMod.IsChecked = Properties.Settings.Default.BaseTheme;
                if (Properties.Settings.Default.PrimeryColor == -1)
                    cboPrm.SelectedIndex = 2;
                else
                    cboPrm.SelectedIndex = Properties.Settings.Default.PrimeryColor;
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error1: code={ex.HResult},msg={ex.Message}");
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        private void WindowSaveSetting()
        {
            try
            {
                if (cboPrm.SelectedIndex > -1)
                {
                    if (WindowState == WindowState.Maximized)
                    {
                        Properties.Settings.Default.Top = RestoreBounds.Top;
                        Properties.Settings.Default.Left = RestoreBounds.Left;
                        Properties.Settings.Default.Height = RestoreBounds.Height;
                        Properties.Settings.Default.Width = RestoreBounds.Width;
                        Properties.Settings.Default.Maximized = true;
                    }
                    else
                    {
                        Properties.Settings.Default.Top = this.Top;
                        Properties.Settings.Default.Left = this.Left;
                        Properties.Settings.Default.Height = this.Height;
                        Properties.Settings.Default.Width = this.Width;
                        Properties.Settings.Default.Maximized = false;
                    }
                    Properties.Settings.Default.BaseTheme = chkMod.IsChecked.Value;
                    Properties.Settings.Default.PrimeryColor = cboPrm.SelectedIndex;
                    if(cboCht.Items.Count > 0) 
                    {
                        int intRtn = 0;
                        int.TryParse(cboCht.SelectedValue.ToString(), out intRtn);
                        Properties.Settings.Default.ChatNo = intRtn;
                    }
                    Properties.Settings.Default.Save();
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error2: code={ex.HResult},msg={ex.Message}");
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }


        private async void Window_Loaded(object sender, RoutedEventArgs e)
        {
            //DBの追加項目チェック
            CheckColumn();
            //初期処理
            SetEnabled_ChatGroup(false);
            btnEject.IsEnabled = false;
            lblInfo.Visibility = Visibility.Hidden;
            picDc.Visibility = Visibility.Hidden;
            picSm.Visibility = Visibility.Hidden;
            picSd.Visibility = Visibility.Hidden;
            picLv.Visibility = Visibility.Hidden;
            picVc1.Visibility = Visibility.Hidden;
            picVc2.Visibility = Visibility.Hidden;
            picVc3.Visibility = Visibility.Hidden;
            picVto.Visibility = Visibility.Hidden;
            WindowLoadSetting();

            try
            {
                cboCht.ItemsSource = ((IListSource)mng()).GetList();
                if (cboCht.Items.Count==0)
                {
                    btnLoad.IsEnabled = false;
                    cboCht.IsEnabled = false;
                }
                else cboCht.SelectedIndex = 0;
                cboCvo.ItemsSource = ((IListSource)cvo()).GetList();
                cboSyt.ItemsSource = ((IListSource)syt()).GetList();
                cboVvx.ItemsSource = ((IListSource)vvx()).GetList();
                cboLng.ItemsSource = ((IListSource)lng()).GetList();
                //システム設定共通設定読み込み
                InitSettingSys();
                InitSettingCom();

                //GPU使用メモリ編集
                GPU_UsageMemory();

                if (cboCht.Items.Count > 0)
                {
                    //引数起動の場合はロードを行う
                    string[] cmds = System.Environment.GetCommandLineArgs();
                    //コマンドライン引数を列挙する
                    int intNo = 0;
                    foreach (string cmd in cmds)
                    {
                        if (cmd.StartsWith("/ch"))
                        {
                            if (int.TryParse(cmd.Replace("/ch", ""), out intNo))
                            {
                                if (intNo > 0)
                                {
                                    cboCht.SelectedValue = intNo;
                                    if (cboCht.SelectedItem == null) break;
                                    if (await LoadLLM()) LoadSetting();
                                    break;
                                }
                            }
                        }
                    }
                }
                //タイマー定義
                timer = new System.Timers.Timer(itrvl);
                timer.Elapsed  += timer_Tick;
                //コマンド起動モード
                if (cboCht.Items.Count > 0)
                {
                    cboCht.SelectedValue = Properties.Settings.Default.ChatNo;
                    if (cboCht.SelectedIndex == -1) cboCht.SelectedIndex = 0;
                    //引数起動の場合はロードを行う
                    string[] cmds = System.Environment.GetCommandLineArgs();
                    //コマンドライン引数を列挙する
                    int intNo = 0;
                    foreach (string cmd in cmds)
                    {
                        if (cmd.StartsWith("/ch"))
                        {
                            if (int.TryParse(cmd.Replace("/ch", ""), out intNo))
                            {
                                if (intNo > 0)
                                {
                                    cboCht.SelectedValue = intNo;
                                    if (cboCht.SelectedItem == null) break;
                                    btnLoad_Click(sender, e);
                                    break;
                                }
                            }
                        }
                    }
                }
                //キーワード設定
                AwakeWord = txtCmd1.Text.Split(",");
                //AsleepWord = txtCmd2.Text.Split(",");
                AsleepWord = txtCmd2.Text.Replace(",", "|");
                AendWord = txtCmd3.Text.Split(",");
                //Speech Recognition
                //Awake設定とイベント定義
                recognizer1 = new SpeechRecognitionEngine(new System.Globalization.CultureInfo(strLng));
                Choices awake = new Choices(AwakeWord);
                GrammarBuilder gb1 = new GrammarBuilder(awake);
                recognizer1.LoadGrammar(new System.Speech.Recognition.Grammar(gb1));
                recognizer1.SpeechRecognized += new EventHandler<SpeechRecognizedEventArgs>(recognizer1_SpeechRecognized);
                //Asleep設定とイベント定義
                //recognizer2 = new SpeechRecognitionEngine(new System.Globalization.CultureInfo(strLng));
                //Choices asleep = new Choices(AsleepWord);
                //GrammarBuilder gb2 = new GrammarBuilder(asleep);
                //recognizer2.LoadGrammar(new System.Speech.Recognition.Grammar(gb2));
                //recognizer2.SpeechRecognized +=  new EventHandler<SpeechRecognizedEventArgs>(recognizer2_SpeechRecognized);
                //Aend設定とイベント定義
                recognizer3 = new SpeechRecognitionEngine(new System.Globalization.CultureInfo(strLng));
                Choices aend = new Choices(AendWord);
                GrammarBuilder gb3 = new GrammarBuilder(aend);
                recognizer3.LoadGrammar(new System.Speech.Recognition.Grammar(gb3));
                recognizer3.SpeechRecognized +=  new EventHandler<SpeechRecognizedEventArgs>(recognizer3_SpeechRecognized);
                if (chkVc1.IsChecked.Value) 
                {
                    //Speech Recognizer1開始
                    recognizer1.SetInputToDefaultAudioDevice();
                    recognizer1.RecognizeAsync(RecognizeMode.Multiple);
                    booVc1 = true;
                }
                if (chkVc2.IsChecked.Value)
                {
                    //Speech Recognizer2開始
                    //recognizer2.SetInputToDefaultAudioDevice();
                    //recognizer2.RecognizeAsync(RecognizeMode.Multiple);
                    booVc2 = true;
                }
                if (chkVc3.IsChecked.Value)
                {
                    //Speech Recognizer3開始
                    recognizer3.SetInputToDefaultAudioDevice();
                    recognizer3.RecognizeAsync(RecognizeMode.Multiple);
                    booVc3 = true;
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error4: code={ex.HResult},msg={ex.Message}");
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                System.Windows.Application.Current.Shutdown();
            }
        }
        private async void btnLoad_Click(object sender, RoutedEventArgs e)
        {
            SetEnabled_LoadGroup(false);
            if (await LoadLLM())
            {
                btnEject_Click(sender, e);
                return;
            }
            LoadSetting();
        }

        private async Task<bool> LoadLLM()
        {
            int intGpu = 0;
            uint intCtx = 0;
            float fltTmp = 0f;
            float fltFrp = 0f;
            int intMxt = 0;
            try
            {
                //初期化処理
                ClearItems();
                //編集画面読み込み
                InitSettingEd();
                //Common設定読み込み
                InitSettingCom();
                string[] strAnt = txtAnt.Text.Split(",");
                if (Lv) dvwMsg.AllowDrop = true;
                else dvwMsg.AllowDrop = false;
                string strTable = $"ch{cboCht.SelectedValue}";
                //パラメータチェック
                if (!File.Exists(txtMdl.Text))
                {
                    await MessageBox_Show("LLM Model file does not exist.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return true;
                }
                if (!int.TryParse(txtGpu.Text, out intGpu)) intGpu = 0;
                if (intGpu == 0) intGpu = DefGpu;
                if (!uint.TryParse(txtCtx.Text, out intCtx)) intCtx = 0;
                if (intCtx == 0) intCtx = DefCtx;
                if (!float.TryParse(txtTmp.Text, out fltTmp)) fltTmp = 0f;
                if (!float.TryParse(txtFrp.Text, out fltFrp)) fltFrp = 0f;
                if (!int.TryParse(txtMxt.Text, out intMxt)) intMxt = DefMxt;
                if (intMxt == 0) intMxt = DefMxt;
                lblInfo.Content = "Now Loading The History...";
                lblInfo.Visibility = Visibility.Visible;
                DoEvents();
                //チャットログ要約処理
                if (Sm)
                {
                    lblInfo.Content = "Now Summarizing The History...";
                    lblInfo.Visibility = Visibility.Visible;
                    DoEvents();
                    var sum = new HistorySummary(DatabasePath);
                    sum.SystemPrompt = txtSys_s.Text;
                    sum.ModelPath = txtMdl_s.Text;
                    sum.ContextSize = uint.Parse(txtCtx_s.Text);
                    sum.GpuLayerCount = int.Parse(txtGpu_s.Text);
                    sum.Temperature = float.Parse(txtTmp_s.Text);
                    sum.AntiPrompt = txtAnt_s.Text;
                    await sum.Run(intCtx, strTable);
                    sum = null;
                }
                else
                {
                    lblInfo.Content = "Now Truncating The History...";
                    lblInfo.Visibility = Visibility.Visible;
                    DoEvents();
                    var sum = new HistorySummary(DatabasePath);
                    sum.Truncate(intCtx, strTable);
                    sum = null;
                }
                //LLMモデルのロードとパラメータの設定
                lblInfo.Content = "Now Loading The History...";
                lblInfo.Visibility = Visibility.Visible;
                DoEvents();
                modPara = new ModelParams(txtMdl.Text)
                {
                    ContextSize = intCtx,
                    GpuLayerCount = intGpu,
                };
                llmWeit = LLamaWeights.LoadFromFile(modPara);
                llmContx = llmWeit.CreateContext(modPara);
                itrEx = new(llmContx);
                //チャットログを読み込みます。
                chtHis = new ChatHistory();
                string strSysprompt = txtSys.Text;
                if (booGrf) strSysprompt += "\n" + strGrs;
                if (booAsf) strSysprompt += "\n" + strAss;
                chtDB = new ChatHistoryDB(DatabasePath, chtHis, strTable, strSysprompt, txtSysOp.Text, strLng);
                chtSess = new(itrEx, chtHis);
                llmHidewd = new LLamaTransforms.KeywordTextOutputStreamTransform(["User: ", "Assistant: "]);
                chtSess.WithOutputTransform(llmHidewd);
                infPara = new InferenceParams()
                {
                    SamplingPipeline = new DefaultSamplingPipeline()
                    {
                        Temperature = fltTmp,
                        Seed = 1337,
                        FrequencyPenalty = fltFrp,
                    },
                    AntiPrompts = strAnt,
                    MaxTokens = intMxt,
                };
                //VOICEVOX Coreをここで読み込んでおく
                InitVoicevox(uint.Parse(cboVvx.SelectedValue.ToString()));
                //GPU使用メモリ編集
                GPU_UsageMemory();
                //Discord Bot Enabledは、Discord Botを起動する
                if (chkBot.IsChecked.Value)
                {
                    strTkn = txtTkn.Text;
                    if (!ulong.TryParse(txtCid.Text, out lngCid)) lngCid = 0;
                    DiscordBot();
                }

                lblInfo.Visibility = Visibility.Hidden;
                if (chkVc1.IsChecked.Value) picVc1.Visibility = Visibility.Visible;
                txtMsg.Focus();
                return false;
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error5: code={ex.HResult},msg={ex.Message}");
                lblInfo.Visibility= Visibility.Hidden;
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return true;
            }
        }
        public static string GetStartupPath()
        {
            return System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location);
        }
        private async void ClearItems()
        {
            //初期化処理
            chtDB = null;
            modPara = null;
            if (llmWeit != null) llmWeit.Dispose();
            llmWeit = null;
            if (llmContx != null) llmContx.Dispose();
            llmContx = null;
            itrEx = null;
            chtHis = null;
            chtSess = null;
            llmHidewd = null;
            infPara = null;
            if (core != null) core.Dispose();
            core = null;

            if (chkBot.IsChecked.Value)
            {
                //Discord Event Stop & Clear
                if (dcclient != null)
                {
                    dcclient.MessageCreated -= OnMessageCreated;
                    dcclient.Ready -= OnClientReady;
                    dcclient.GuildAvailable -= OnGuildAvailable;
                    dcclient.VoiceStateUpdated -= OnVoiceStateUpdated;
                    if (dcvoiceCon is not null) dcvoiceCon.Disconnect();
                    await dcclient.DisconnectAsync();
                    dcclient.Dispose();
                    picDc.Visibility = Visibility.Hidden;
                    dcclient = null;
                }
            }
        }
        private async Task Chat(string strUserInput)
        {
            try
            {
                if (!Wt)
                {
                    Wt = true;
                    if (booVc2 && CheckAslp(strUserInput))
                    {
                        Dispatcher.Invoke((Action)(() =>
                        {
                            chkMic.IsChecked = false;
                            chkMic_Change();
                        }));
                        Wt = false;
                        return;
                    }
                    ChatHistory.Message msgText = new(AuthorRole.User, strUserInput);
                    WriteHistory(AuthorRole.User, strUserInput);
                    Dispatcher.Invoke(dvwMsg_Refresh);
                    // 回答の表示
                    string strMsg = "";
                    await foreach (string strText in chtSess.ChatAsync(msgText, infPara)) strMsg += strText;
                    //発信するときは「User:」や「Assistant:」を抜く
                    string strSndmsg = EditAiMsg(strMsg);
                    //画像生成キーワード探索
                    if (strMsg.IndexOf("[")  != -1)
                    {
                        var rgxRtn = new Regex(@"\[(.+?)\]").Matches(strMsg);
                        if (rgxRtn.Count > 0)
                        {
                            Sdprompt = rgxRtn[0].Value.Replace("[", "").Replace("]", "").Trim();
                        }
                    }
                    WriteHistory(AuthorRole.Assistant, strSndmsg);
                    Dispatcher.Invoke(dvwMsg_Refresh);
                    if (booSpk)
                    {
                        SpeechSynthesis(strSndmsg); //音声ソフト実行
                        if (booMic) Thread.Sleep(intHwt * 1000); //マイクONの時だけSleepを入れる
                    }
                    Wt = false;
                    booFgf = true;
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error6: code={ex.HResult},msg={ex.Message}");
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        private string EditAiMsg(string strMsg)
        {
            return strMsg.Replace("User:", "").Replace("Assistant:", "").Replace("assistant:", "").Trim();
        }

        private async Task StopRecognizer()
        {
            if (recognizer != null)
            {
                //AI会話ストップ
                await recognizer.ContinuousRecognitionSession.CancelAsync();
                // SpeechRecognitionの初期化
                recognizer.HypothesisGenerated -= ContinuousRecognitionSession_HypothesisGenerated;
                recognizer.ContinuousRecognitionSession.ResultGenerated -= ContinuousRecognitionSession_ResultGenerated;
                recognizer.ContinuousRecognitionSession.Completed -= ContinuousRecognitionSession_Completed;
                recognizer.StateChanged -= Recognizer_StateChanged;
                recognizer.Dispose();
                recognizer = null;
            }
        }
        private async Task StartRecognizer()
        {
            // SpeechRecognitionの初期化
            if (recognizer != null)
            {
                recognizer.HypothesisGenerated -= ContinuousRecognitionSession_HypothesisGenerated;
                recognizer.ContinuousRecognitionSession.ResultGenerated -= ContinuousRecognitionSession_ResultGenerated;
                recognizer.ContinuousRecognitionSession.Completed -= ContinuousRecognitionSession_Completed;
                recognizer.StateChanged -= Recognizer_StateChanged;
                recognizer.Dispose();
                recognizer = null;
            }
            // SpeechRecognitionの設定
            recognizer = new Windows.Media.SpeechRecognition.SpeechRecognizer(new Windows.Globalization.Language(strLng));
            // Apply the dictation topic constraint to optimize for dictated freeform speech.
            await recognizer.CompileConstraintsAsync();

            recognizer.HypothesisGenerated += ContinuousRecognitionSession_HypothesisGenerated;
            recognizer.ContinuousRecognitionSession.ResultGenerated += ContinuousRecognitionSession_ResultGenerated;
            //AI会話タイムアウト
            recognizer.ContinuousRecognitionSession.Completed += ContinuousRecognitionSession_Completed;
            //AI会話ステータス変更
            recognizer.StateChanged += Recognizer_StateChanged;
            //AI会話スタート
            await recognizer.ContinuousRecognitionSession.StartAsync();
        }

        private async void ContinuousRecognitionSession_ResultGenerated(SpeechContinuousRecognitionSession sender, SpeechContinuousRecognitionResultGeneratedEventArgs e)
        {
            Debug.WriteLine($"rs4={recognizer.State}+{e.Result.Text},Wt={Wt}, booMic={booMic}");
            //AI会話
            if (!Wt && booMic)
            {
                timerCnt = 0;
                timer.Stop();
                await Chat(EDB(e.Result.Text));
                timer.Start();
            }
        }
        private async void ContinuousRecognitionSession_Completed(SpeechContinuousRecognitionSession sender, SpeechContinuousRecognitionCompletedEventArgs e)
        {
            Debug.WriteLine($"rs2={recognizer.State}");
            if (booMic)
            {
                await StartRecognizer();
            }
        }
        private void Recognizer_StateChanged(Windows.Media.SpeechRecognition.SpeechRecognizer sender, SpeechRecognizerStateChangedEventArgs args)
        {
            try 
            {
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error37: code={ex.HResult},msg={ex.Message}");
            }
        }
        private void ContinuousRecognitionSession_HypothesisGenerated(Windows.Media.SpeechRecognition.SpeechRecognizer sender, SpeechRecognitionHypothesisGeneratedEventArgs args)
        {
            try
            {
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error38: code={ex.HResult},msg={ex.Message}");
            }
        }

        private DataTable mng()
        {
            try
            {
                DataTable dt = new DataTable();
                using (SQLiteConnection con = new SQLiteConnection("Data Source=" + DatabasePath))
                {
                    SQLiteDataAdapter adp = new SQLiteDataAdapter("SELECT * from mng order by no;", con);
                    adp.Fill(dt);
                }
                return dt;
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error8: code={ex.HResult},msg={ex.Message}");
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return null;
            }
        }
        private DataTable ch()
        {
            try
            {
                DataTable dt = new DataTable();
                SQLiteDataAdapter adp;
                using (SQLiteConnection con = new SQLiteConnection("Data Source=" + DatabasePath))
                {
                    adp = new SQLiteDataAdapter($"SELECT replace(id,'Assistant','{strAI}') id,replace(replace(replace(replace(replace(msg,'User',''),'Assistant',''),char(13, 10),''),char(10),''),':','') msg,sq FROM ch{cboCht.SelectedValue} where sq>3 and flg=0 order by sq;", con);
                    adp.Fill(dt);
                }
                return dt;
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error9: code={ex.HResult},msg={ex.Message}");
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return null;
            }
        }
        private DataTable syt()
        {
            DataTable dt = new DataTable();
            using (SQLiteConnection con = new SQLiteConnection("Data Source=" + DatabasePath))
            {
                SQLiteDataAdapter adp = new SQLiteDataAdapter("SELECT * from syt order by no;", con);
                adp.Fill(dt);
            }
            return dt;
        }
        private DataTable cvo()
        {
            DataTable dt = new DataTable();
            using (SQLiteConnection con = new SQLiteConnection("Data Source=" + DatabasePath))
            {
                SQLiteDataAdapter adp = new SQLiteDataAdapter("SELECT * from cvo order by no;", con);
                adp.Fill(dt);
            }
            return dt;
        }
        private DataTable vvx()
        {
            DataTable dt = new DataTable();
            using (SQLiteConnection con = new SQLiteConnection("Data Source=" + DatabasePath))
            {
                SQLiteDataAdapter adp = new SQLiteDataAdapter("SELECT * from vvx order by no;", con);
                adp.Fill(dt);
            }
            return dt;
        }

        private DataTable lng()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("cd");
            dt.Columns.Add("nam");

            dt.Rows.Add("ja-JP", "Japanese");
            dt.Rows.Add("en-US", "United States");
            dt.Rows.Add("fr-FR", "France");
            dt.Rows.Add("de-DE", "Germany");
            dt.Rows.Add("ko-KR", "Korean");
            dt.Rows.Add("it-IT", "Italy");
            dt.Rows.Add("ru-RU", "Russian");
            return dt;
        }

        private void LoadSetting()
        {
            dtCht = ch();
            dvwMsg.DataContext = dtCht;
            dvwMsg.Items.Refresh();
            dvwMsg_Refresh();

            SetEnabled_ChatGroup(true);
            chkMic.IsChecked = false;
            chkSpk.IsChecked = false;
            booMic = false;
            booSpk = false;
            txtMsg.Focus();
        }
        private void WriteHistory(AuthorRole aurID, string strUserInput)
        {
            try
            {
                DataRow dr;
                long lngRtn = 0;
                lngRtn = chtDB.WriteHistory(aurID, (aurID == AuthorRole.User ? "User: " : "") + strUserInput);
                dr = dtCht.NewRow();
                dr[0] = Roles.FirstOrDefault(v => v.Value.Equals(aurID)).Key;
                dr[1] = strUserInput;
                dr[2] = lngRtn;
                dtCht.Rows.Add(dr);
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error10: code={ex.HResult},msg={ex.Message}");
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }
        private void dvwMsg_Refresh()
        {
            dvwMsg.Items.Refresh();
            if (dvwMsg.Items.Count <= 1) return;
            dvwMsg.ScrollIntoView(dvwMsg.Items.GetItemAt(dvwMsg.Items.Count - 1));

            DataRow dr = dtCht.Rows[dtCht.Rows.Count - 1];
            string strId = dr[0].ToString();
            DoEvents();
            if (strId != null)
            {
                if (strId == strAI)
                {
                    string strMsg = dr[1].ToString();
                    picEmt.Source = SelectEmtImg(SearchEmotion(strMsg));
                    DoEvents();
                }
            }
        }
        private ImageSource SelectEmtImg(int ix)
        {
            ImageSource imgRtn;
            switch (ix)
            {
                case 1:
                    imgRtn = picSml.ImageSource;
                    break;
                case 2:
                    imgRtn = picAfc.ImageSource;
                    break;
                case 3:
                    imgRtn = picSkp.ImageSource;
                    break;
                case 4:
                    imgRtn = picCnc.ImageSource;
                    break;
                case 5:
                    imgRtn = picNeg.ImageSource;
                    break;
                default:
                    imgRtn = picUsu.ImageSource;
                    break;
            }
            return imgRtn;
        }
        private void DoEvents()
        {
            DispatcherFrame frame = new DispatcherFrame();
            var callback = new DispatcherOperationCallback(obj =>
            {
                ((DispatcherFrame)obj).Continue = false;
                return null;
            });
            Dispatcher.CurrentDispatcher.BeginInvoke(DispatcherPriority.Background, callback, frame);
            Dispatcher.PushFrame(frame);
        }
        private async Task<bool> CheckEd()
        {
            //パラメータチェック
            if (txtNam.Text.IndexOf("\'")>0 || txtNam.Text.IndexOf("\"")>0)
            {
                await MessageBox_Show("Chat name contains characters that cannot be used.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return (true);
            }
            if (txtNam.Text.Trim() == "")
            {
                await MessageBox_Show("Chat name not entered.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return (true);
            }
            if (txtSys.Text.IndexOf("\'")>0 || txtSys.Text.IndexOf("\"")>0)
            {
                await MessageBox_Show("System Prompt contains characters that cannot be used.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return (true);
            }
            if (txtMdl.Text.IndexOf("\'")>0 || txtMdl.Text.IndexOf("\"")>0)
            {
                await MessageBox_Show("LLM Path contains characters that cannot be used.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return (true);
            }
            if (txtAnt.Text.IndexOf("\'")>0 || txtAnt.Text.IndexOf("\"")>0)
            {
                await MessageBox_Show("Anti Prompt contains characters that cannot be used.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return (true);
            }

            int intCtx = 0;
            int intGpu = 0;
            float fltTmp = 0.0f;
            float fltFrp = 0.0f;
            int intMxt = 0;
            if (!int.TryParse(txtCtx.Text, out intCtx)) intCtx = DefCtx;
            if (intCtx == 0) intCtx = DefCtx;
            if (!float.TryParse(txtTmp.Text, out fltTmp)) fltTmp = DefTmp;
            if (fltTmp == 0) fltTmp = DefTmp;
            if (!int.TryParse(txtGpu.Text, out intGpu)) intGpu = DefGpu;
            if (intGpu == 0) intGpu = DefGpu;
            if (txtSys.Text.Trim() == "") txtSys.Text = DefSys;
            if (txtAnt.Text.Trim() == "") txtAnt.Text = DefAnt;
            if (!float.TryParse(txtFrp.Text, out fltFrp)) fltFrp = 0.0f;
            if (!int.TryParse(txtMxt.Text, out intMxt)) intMxt = DefMxt;
            if (intMxt == 0) intMxt = DefMxt;

            txtCtx.Text = intCtx.ToString();
            txtTmp.Text = fltTmp.ToString("F");
            txtGpu.Text = intGpu.ToString();
            txtFrp.Text = fltFrp.ToString("F");
            txtMxt.Text = intMxt.ToString();

            if (!File.Exists(txtMdl.Text))
            {
                await MessageBox_Show("LLM Model file does not exist.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                txtMdl.Focus();
                return (true);
            }

            if (chkBot.IsChecked.Value)
            {
                if (txtTkn.Text == "")
                {
                    await MessageBox_Show("Discord Token contains characters that cannot be used.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    txtTkn.Focus();
                    return (true);
                }
            }
            return (false);
        }
        private async Task<bool> CheckSm(bool mb = true)
        {
            if (txtMdl_s.Text.Trim() == "")
            {
                if (!mb) return (true); //メッセージBOX非表示モードの時はエラーにする
            }
            else
            {
                if (txtSys_s.Text.IndexOf("\'")>0 || txtSys_s.Text.IndexOf("\"")>0)
                {
                    await MessageBox_Show("Summary System Prompt contains characters that cannot be used.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
                if (txtMdl_s.Text.IndexOf("\'")>0 || txtMdl.Text.IndexOf("\"")>0)
                {
                    if (mb) await MessageBox_Show("Summary LLM Path contains characters that cannot be used.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
                if (!File.Exists(txtMdl_s.Text))
                {
                    if (mb) await MessageBox_Show("Summary LLM Model file does not exist.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
                if (txtAnt_s.Text.IndexOf("\'")>0 || txtAnt_s.Text.IndexOf("\"")>0)
                {
                    await MessageBox_Show("Summary Anti Prompt contains characters that cannot be used.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
            }

            uint intCtx = 0;
            int intGpu = 0;
            float fltTmp = 0.0f;
            if (!uint.TryParse(txtCtx_s.Text, out intCtx)) intCtx = 0;
            if (intCtx == 0) intCtx = DefCtx;
            if (!float.TryParse(txtTmp_s.Text, out fltTmp)) fltTmp = 0.0f;
            if (!int.TryParse(txtGpu_s.Text, out intGpu)) intGpu = 0;
            if (intGpu == 0) intGpu = DefGpu;
            txtCtx_s.Text = intCtx.ToString();
            txtTmp_s.Text = fltTmp.ToString("F");
            txtGpu_s.Text = intGpu.ToString();
            if (txtSys_s.Text.Trim() == "") txtSys_s.Text = DefSys_s;
            if (txtAnt_s.Text.Trim() == "") txtAnt_s.Text = DefAnt;

            return (false);
        }
        private async Task<bool> CheckSd(bool mb = true)
        {

            if (txtMdl_d.Text.Trim() == "")
            {
                if (!mb) return (true);  //メッセージBOX非表示モードの時はエラーにする
            }
            else
            {
                if (txtMdl_d.Text.IndexOf("\'")>0 || txtMdl_d.Text.IndexOf("\"")>0)
                {
                    if (mb) await MessageBox_Show("Stable Diffusion Model Path characters that cannot be used.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
                if (!File.Exists(txtMdl_d.Text))
                {
                    if (mb) await MessageBox_Show("Stable Diffusion Model file does not exist.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
            }
            if (txtVae.Text.Trim() != "")
            {
                if (txtVae.Text.IndexOf("\'")>0 || txtVae.Text.IndexOf("\"")>0)
                {
                    if (mb) await MessageBox_Show("Vae Path characters that cannot be used.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
                if (!File.Exists(txtVae.Text))
                {
                    if (mb) await MessageBox_Show("Vae file does not exist.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
            }
            if (txtEmb.Text.Trim() != "")
            {
                if (txtEmb.Text.IndexOf("\'")>0 || txtEmb.Text.IndexOf("\"")>0)
                {
                    if (mb) await MessageBox_Show("Embedding Path characters that cannot be used.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
                if (!File.Exists(txtEmb.Text))
                {
                    if (mb) await MessageBox_Show("Embedding file does not exist.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
            }

            return (false);
        }
        private async Task<bool> CheckLv(bool mb = true)
        {
            if (txtMdl_l.Text.Trim() == "")
            {
                if (!mb) return (true);  //メッセージBOX非表示モードの時はエラーにする
            }
            else
            {
                if (txtSys_l.Text.IndexOf("\'")>0 || txtSys_l.Text.IndexOf("\"")>0)
                {
                    if (mb) await MessageBox_Show("Llava System Prompt contains characters that cannot be used.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
                if (txtMdl_l.Text.IndexOf("\'")>0 || txtMdl_l.Text.IndexOf("\"")>0)
                {
                    if (mb) await MessageBox_Show("Llava LLM Path contains characters that cannot be used.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
                if (!File.Exists(txtMdl_l.Text))
                {
                    if (mb) await MessageBox_Show("Llava LLM Model file does not exist.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
                if (txtClp.Text.IndexOf("\'")>0 || txtClp.Text.IndexOf("\"")>0)
                {
                    if (mb) await MessageBox_Show("Llava Clip Path contains characters that cannot be used.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
                if (!File.Exists(txtClp.Text))
                {
                    if (mb) await MessageBox_Show("Llava Clip Model file does not exist.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
                if (txtAnt_l.Text.IndexOf("\'")>0 || txtAnt_l.Text.IndexOf("\"")>0)
                {
                    if (mb) await MessageBox_Show("Llava AntiPrompt contains characters that cannot be used.", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                    return (true);
                }
            }

            uint intCtx = 0;
            int intGpu = 0;
            float fltTmp = 0.0f;
            if (!uint.TryParse(txtCtx_l.Text, out intCtx)) intCtx = 0;
            if (intCtx == 0) intCtx = DefCtx;
            if (!float.TryParse(txtTmp_l.Text, out fltTmp)) fltTmp = 0.0f;
            if (!int.TryParse(txtGpu_l.Text, out intGpu)) intGpu = 0;
            if (intGpu == 0) intGpu = DefGpu;
            txtCtx_l.Text = intCtx.ToString();
            txtTmp_l.Text = fltTmp.ToString("F");
            txtGpu_l.Text = intGpu.ToString();
            if (txtSys_l.Text.Trim() == "") txtSys_l.Text = DefSys_l;
            if (txtAnt_l.Text.Trim() == "") txtAnt_l.Text = DefAnt;

            return (false);
        }
        private void CheckCom()
        {
            if (txtSysOp.Text.Trim() == "") txtSysOp.Text = DefSysOp;
            if (txtCmd1.Text.Trim() == "") txtCmd1.Text = DefCmd1;
            if (txtCmd2.Text.Trim() == "") txtCmd2.Text = DefCmd2;
            if (txtCmd3.Text.Trim() == "") txtCmd3.Text = DefCmd3;
            if (txtGrk.Text.Trim() == "") txtGrk.Text = DefGrk;
            if (txtGrs.Text.Trim() == "") txtGrs.Text = DefGrs;
            if (txtAsk.Text.Trim() == "") txtAsk.Text = DefAsk;
            if (txtAss.Text.Trim() == "") txtAss.Text = DefAss;
            if (txtVto.Text.Trim() == "") txtVto.Text = DefVto.ToString();
            if (txtAst.Text.Trim() == "") txtAst.Text = DefAst.ToString();
            if (txtBan.Text.Trim() == "") txtBan.Text = DefBan;
            if (txtHwt.Text.Trim() == "") txtHwt.Text = DefHwt.ToString();

            booGrf = chkGrf.IsChecked.Value;
            strGrk = txtGrk.Text.Trim();
            strGrs = txtGrs.Text.Trim();
            booAsf = chkAsf.IsChecked.Value;
            strAsk = txtAsk.Text.Trim();
            strAss = txtAss.Text.Trim();
            booVtf = chkVtf.IsChecked.Value;
            intVto = 0;
            if (!uint.TryParse(txtVto.Text, out intVto)) intVto = DefVto;
            txtVto.Text = intVto.ToString();
            intAst = 0;
            if (!uint.TryParse(txtAst.Text, out intAst)) intAst = DefAst;
            txtAst.Text = intAst.ToString();
            booBnf = chkBnf.IsChecked.Value;
            strBan = txtBan.Text.Trim();
            intHwt = 0;
            if (!int.TryParse(txtHwt.Text, out intHwt)) intHwt = DefHwt;
            txtHwt.Text = intHwt.ToString();
        }
        public MemoryStream CevioAI(string strMsg, string strCast, bool booPlay = true)
        {
            try
            {
                var ms = new MemoryStream();
                string strWavPath = GetStartupPath() + @"\output.wav";
                dynamic service = Activator.CreateInstance(Type.GetTypeFromProgID("CeVIO.Talk.RemoteService2.ServiceControl2V40"));
                service.StartHost(false);
                dynamic talker = Activator.CreateInstance(Type.GetTypeFromProgID("CeVIO.Talk.RemoteService2.Talker2V40"));
                talker.Cast = strCast;
                if (booPlay)
                {
                    dynamic result = talker.Speak(strMsg);
                    result.Wait();
                    ms.Dispose();
                    ms = null;
                }
                else
                {
                    dynamic result = talker.OutputWaveToFile(strMsg, strWavPath);
                    using (FileStream file = new FileStream(strWavPath, FileMode.Open, FileAccess.Read))
                        file.CopyTo(ms);
                }
                //開放忘れるとメモリリーク
                System.Runtime.InteropServices.Marshal.ReleaseComObject(talker);
                System.Runtime.InteropServices.Marshal.ReleaseComObject(service);
                return ms;
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error11: code={ex.HResult},msg={ex.Message}");
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return null;
            }
        }

        public void InitVoicevox(uint intSpeaker)
        {
            MainForm me = new MainForm();
            core = me.GetDefaultCoreObject();
            core.LoadModel(intSpeaker);
        }
        public MemoryStream Voicevox(string strMsg, uint intSpeaker, bool booPlay = true)
        {
            try
            {
                //MainForm me = new MainForm();
                //Core core = me.GetDefaultCoreObject();
                //core.LoadModel(intSpeaker);
                AudioQueryOptions audioQueryOptions = new AudioQueryOptions()
                {
                    kana = false
                };
                bool enableInterrogativeUpspeak = false;
                string json = core.AudioQuery(strMsg, intSpeaker, audioQueryOptions);
                SynthesisOptions synthesisOptions = new SynthesisOptions()
                {
                    enable_interrogative_upspeak = enableInterrogativeUpspeak
                };
                // When
                byte[] wavData = core.Synthesis(json, intSpeaker, synthesisOptions);
                MemoryStream ms = new MemoryStream(wavData);
                if (booPlay)
                {
                    var player = new SoundPlayer(ms);
                    player.PlaySync();
                    ms.Dispose();
                    ms = null;
                }
                return ms;
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error12: code={ex.HResult},msg={ex.Message}");
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return null;
            }
        }
        public Core GetDefaultCoreObject()
        {
            InitializeOptions options = new InitializeOptions(GetOpenJtalkDictDir());
            options.LoadAllModels = false;
            return new Core(options);
        }
        public string GetOpenJtalkDictDir()
        {
            return System.IO.Path.Combine(GetThisAppDirectory() ?? "", "open_jtalk_dic_utf_8-1.11");
        }
        static public Assembly GetThisAssembly()
        {
            return Assembly.GetExecutingAssembly();
        }
        static public string? GetThisAppDirectory()
        {
            string appPath = GetThisAssembly().Location;
            return System.IO.Path.GetDirectoryName(appPath);
        }
        private void GPU_UsageMemory()
        {
            try
            {
                var category = new PerformanceCounterCategory("GPU Adapter Memory");
                var counterNames = category.GetInstanceNames();
                var gpuCountersDedicated = new List<PerformanceCounter>();
                var gpuCountersShared = new List<PerformanceCounter>();
                var result = 0f;
                double GpuUse = 0d;
                foreach (string counterName in counterNames)
                {
                    foreach (var counter in category.GetCounters(counterName))
                    {
                        if (counter.CounterName == "Dedicated Usage")
                        {
                            gpuCountersDedicated.Add(counter);
                        }
                    }
                }
                gpuCountersDedicated.ForEach(x =>
                {
                    _ = x.NextValue();
                });
                Task.Delay(1000);
                gpuCountersDedicated.ForEach(x =>
                {
                    result += x.NextValue();
                });
                double usage = (double)result;
                GpuUse = Math.Round(usage / 107374182.4, MidpointRounding.AwayFromZero);
                GpuUse = GpuUse / 10;
                lblGpu.Content = $"{GpuUse.ToString("F")} GB";
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error13: code={ex.HResult},msg={ex.Message}");
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }
        private async void DiscordBot()
        {
            if (string.IsNullOrWhiteSpace(strTkn))
            {
                Console.WriteLine("Please specify a token in the DISCORD_TOKEN environment variable.");
                Environment.Exit(1);
                return;
            }
            dcconfig = new()
            {
                Token = strTkn,
                TokenType = TokenType.Bot,
                Intents = DiscordIntents.AllUnprivileged | DiscordIntents.MessageContents | DiscordIntents.GuildVoiceStates
            };
            dcclient = new(dcconfig);
            dcclient.UseVoiceNext();

            //メッセージイベント
            dcclient.MessageCreated += OnMessageCreated;
            dcclient.Ready += OnClientReady;
            dcclient.GuildAvailable += OnGuildAvailable;
            dcclient.VoiceStateUpdated += OnVoiceStateUpdated;

            dcstatus = new("with fire", DSharpPlus.Entities.ActivityType.Playing);
            await dcclient.ConnectAsync(dcstatus, UserStatus.Online);
            picDc.Visibility = Visibility.Visible;
        }
        private async Task OnMessageCreated(DiscordClient client, MessageCreateEventArgs e)
        {
            //ボットに応答しない
            if (e.Message.Author.Id==client.CurrentUser.Id) return;
            //ターゲットチャンネル
            if (lngCid != 0 && e.Channel.Id != lngCid) return;
            if (!Wt)
            {
                Wt = true;
                ChatHistory.Message msg = new(AuthorRole.User, "User: " + e.Message.Content);
                WriteHistory(AuthorRole.User, e.Message.Content);
                Dispatcher.Invoke(dvwMsg_Refresh);
                // 回答の表示
                string strMsg = "";
                await foreach (string strAns in chtSess.ChatAsync(msg, infPara)) strMsg += strAns;
                //発信するときは「User:」や「Assistant:」を抜く
                string strSndmsg = EditAiMsg(strMsg);
                await e.Message.RespondAsync(strSndmsg);
                WriteHistory(AuthorRole.Assistant, strSndmsg);
                Dispatcher.Invoke(dvwMsg_Refresh);
                if (dcvoiceCon is not null) //Voiceチャンネルが開いているときは音声を送信
                {
                    MemoryStream msRes = SpeechSynthesis(strSndmsg, false);
                    await SendAsync(dcvoiceCon, msRes);
                }
                Wt = false;
            }
        }

        private Task OnClientReady(DiscordClient client, ReadyEventArgs e)
        {
            Console.WriteLine("Bot is ready!");
            return Task.CompletedTask;
        }

        private Task OnGuildAvailable(DiscordClient client, GuildCreateEventArgs e)
        {
            Console.WriteLine($"Guild available: {e.Guild.Name}");
            return Task.CompletedTask;
        }

        private async Task OnVoiceStateUpdated(DiscordClient client, VoiceStateUpdateEventArgs e)
        {
            try
            {
                //Bot以外のチャンネルが開いた場合
                if (e.After.Channel != null && !e.After.User.IsBot)
                {
                    Console.WriteLine($"{e.After.User.Username} joined voice channel {e.After.Channel.Name}");

                    var vnext = client.GetVoiceNext();
                    var connection = await vnext.ConnectAsync(e.After.Channel);

                    dcvoiceCon = connection;

                }
                //Botが退出した場合はコネクションをNULLにする
                if (e.After.Channel == null && e.After.User.IsBot)
                {
                    dcvoiceCon = null;
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error14: code={ex.HResult},msg={ex.Message}");
            }
        }
        private async Task SendAsync(VoiceNextConnection connection, MemoryStream ms)
        {
            try
            {
                var transmit = connection.GetTransmitSink();
                var pcm = ConvertAudioToPcm(ms);
                await pcm.CopyToAsync(transmit);
                await pcm.DisposeAsync();
                ms.Close();
                ms.Dispose();
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error15: code={ex.HResult},msg={ex.Message}");
            }
        }
        private Stream ConvertAudioToPcm(MemoryStream ms)
        {
            try
            {
                var ffmpeg = Process.Start(new ProcessStartInfo
                {
                    FileName = "ffmpeg",
                    Arguments = $@"-i pipe:0 -ac 2 -f s16le -ar 48000 pipe:1",
                    RedirectStandardInput = true,
                    RedirectStandardOutput = true,
                    UseShellExecute = false
                });

                ffmpeg.StandardInput.BaseStream.WriteAsync(ms.ToArray(), 0, (int)ms.Length);
                ffmpeg.StandardInput.BaseStream.FlushAsync();
                return ffmpeg.StandardOutput.BaseStream;
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error16: code={ex.HResult},msg={ex.Message}");
                return null;
            }
        }

        private MemoryStream SpeechSynthesis(string strMsg, bool booPlay = true)
        {
            switch (intCboSyt) //音声ソフト選択
            {
                case 1:
                    return CevioAI(strMsg, strCboCvo, booPlay);
                case 2:
                    return Voicevox(strMsg, intCboVvx, booPlay);
            }
            return null;
        }
        private int SearchEmotion(string strMsg)
        {
            //Smiling
            if (Regex.IsMatch(strMsg, "😀|😃|😄|😁|😆|😅|🤣|😂|🙂|🙃|😉|😊|😇")) return 1;
            //Affection
            if (Regex.IsMatch(strMsg, "🥰|😍|🤩|😘|😗|☺|😚|😙|🥲|💌|💘|💝|💖|💗|💓|💞|💕|💟|❣|❤|🧡|💛|💚|💙|💜|🤎|🖤|🤍|💋")) return 2;
            //Skeptical
            if (Regex.IsMatch(strMsg, "🤐|🤨|😐|😑|😶|😶‍🌫️|😏|😒|🙄|😬|😮‍💨|🤥")) return 3;
            //Concerned
            if (Regex.IsMatch(strMsg, "😕|😟|🙁|☹|😮|😯|😲|😳|🥺|🥹|😦|😧|😨|😰|😥|😢|😭|😱|😖|😣|😞|😓|😩|😫|🥱")) return 4;
            //Negative
            if (Regex.IsMatch(strMsg, "😤|😡|😠|🤬|😈|👿|💀|☠")) return 5;
            return 0;
        }
        private async void btnEject_Click(object sender, RoutedEventArgs e)
        {
            ClearItems();
            SetEnabled_LoadGroup(true);
            dvwMsg.DataContext = null;
            SetEnabled_ChatGroup(false);
            chkMic.IsChecked = false;
            chkMic_Change();
            chkMic.IsEnabled = false;
            chkSpk.IsChecked = false;
            chkSpk_Change();
            chkSpk.IsEnabled = false;
            lblSyt.Content = "";
            dvwMsg.AllowDrop = false;
            Wt = false;
            picEmt.Source = SelectEmtImg(0);
            picVc1.Visibility = Visibility.Hidden;
            picVc2.Visibility = Visibility.Hidden;
            GPU_UsageMemory(); //GPU使用メモリ編集
        }
        private void SetEnabled_LoadGroup(bool booIsEnabled)
        {
            btnLoad.IsEnabled = booIsEnabled;
            cboCht.IsEnabled = booIsEnabled;
            btnCht.IsEnabled = booIsEnabled;
            btnEdt.IsEnabled = booIsEnabled;
            btnSys.IsEnabled = booIsEnabled;
            btnCom.IsEnabled = booIsEnabled;
        }
        private void InitSettingEd()
        {
            try
            {
                btnUpd.IsEnabled = true;
                chkDel.IsEnabled = true;
                picUsu.ImageSource = new BitmapImage(new Uri(strEmtPath[0], UriKind.Relative));
                picSml.ImageSource = new BitmapImage(new Uri(strEmtPath[1], UriKind.Relative));
                picAfc.ImageSource = new BitmapImage(new Uri(strEmtPath[2], UriKind.Relative));
                picSkp.ImageSource = new BitmapImage(new Uri(strEmtPath[3], UriKind.Relative));
                picCnc.ImageSource = new BitmapImage(new Uri(strEmtPath[4], UriKind.Relative));
                picNeg.ImageSource = new BitmapImage(new Uri(strEmtPath[5], UriKind.Relative));
                txtMdl.AllowDrop = true;
                btnUsu.AllowDrop = true;
                btnSml.AllowDrop = true;
                btnAfc.AllowDrop = true;
                btnSkp.AllowDrop = true;
                btnCnc.AllowDrop = true;
                btnNeg.AllowDrop = true;
                chkDel.IsChecked = false;
                txtSeq.Text = "0";
                txtNam.Text = "";
                txtSys.Text = "";
                txtCtx.Text = DefCtx.ToString();
                txtTmp.Text = DefTmp.ToString();
                txtGpu.Text = DefGpu.ToString();
                txtMdl.Text = "";
                txtAnt.Text = DefAnt;
                txtFrp.Text = "0.0";
                txtMxt.Text = DefMxt.ToString();
                cboSyt.SelectedIndex = 0;
                cboCvo.SelectedIndex = 0;
                cboVvx.SelectedIndex = 0;
                chkBot.IsChecked = false;
                txtTkn.Text = "";
                txtCid.Text = "";

                if (cboCht.SelectedIndex == -1)
                {
                    btnUpd.IsEnabled = false;
                    chkDel.IsEnabled = false;
                    return;
                }
                txtSeq.Text = cboCht.SelectedValue.ToString();
                var conSb = new SQLiteConnectionStringBuilder { DataSource = DatabasePath };
                var con = new SQLiteConnection(conSb.ToString());
                con.Open();
                using (var cmd = new SQLiteCommand(con))
                {
                    cmd.CommandText = $"select * from mng where no={txtSeq.Text}";
                    using (var reader = cmd.ExecuteReader())
                    {
                        if (reader.Read())
                        {
                            txtNam.Text = reader["nam"].ToString();
                            txtSys.Text = reader["sys"].ToString();
                            txtCtx.Text = reader["ctx"].ToString();
                            txtTmp.Text = reader["tmp"].ToString();
                            txtGpu.Text = reader["gpu"].ToString();
                            txtMdl.Text = reader["mdl"].ToString();
                            cboSyt.SelectedValue = reader["syt"];
                            intCboSyt = int.Parse(reader["syt"].ToString());
                            cboCvo.SelectedValue = reader["cvo"];
                            strCboCvo = reader["cvo"].ToString();
                            cboVvx.SelectedValue = reader["vvx"];
                            intCboVvx = uint.Parse(reader["vvx"].ToString());
                            chkBot.IsChecked = reader["bot"].ToString() == "1" ? true : false;
                            txtTkn.Text = reader["tkn"].ToString();
                            txtCid.Text = reader["cid"].ToString();

                            if (reader["usu"].ToString() != "") picUsu.ImageSource = new BitmapImage(new Uri(reader["usu"].ToString(), UriKind.Relative));
                            if (reader["sml"].ToString() != "") picSml.ImageSource = new BitmapImage(new Uri(reader["sml"].ToString(), UriKind.Relative));
                            if (reader["afc"].ToString() != "") picAfc.ImageSource = new BitmapImage(new Uri(reader["afc"].ToString(), UriKind.Relative));
                            if (reader["skp"].ToString() != "") picSkp.ImageSource = new BitmapImage(new Uri(reader["skp"].ToString(), UriKind.Relative));
                            if (reader["cnc"].ToString() != "") picCnc.ImageSource = new BitmapImage(new Uri(reader["cnc"].ToString(), UriKind.Relative));
                            if (reader["neg"].ToString() != "") picNeg.ImageSource = new BitmapImage(new Uri(reader["neg"].ToString(), UriKind.Relative));

                            if (int.Parse(reader["syt"].ToString()) == 1) { lblSyt.Content = cboCvo.Text; }
                            if (int.Parse(reader["syt"].ToString()) == 2) { lblSyt.Content = cboVvx.Text; }

                            txtAnt.Text = reader["ant"].ToString();
                            txtFrp.Text = reader["frp"].ToString();
                            txtMxt.Text = reader["mxt"].ToString();
                            if (txtAnt.Text=="") txtAnt.Text = DefAnt;
                        }
                    }
                }
                con.Close();
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error17: code={ex.HResult},msg={ex.Message}");
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        private async void InitSettingSys()
        {
            txtCtx_s.AllowDrop = true;
            txtTmp_s.AllowDrop = true;
            txtGpu_s.AllowDrop = true;
            txtMdl_s.AllowDrop = true;
            txtMdl_d.AllowDrop = true;
            txtVae.AllowDrop = true;
            txtEmb.AllowDrop = true;
            txtCtx_l.AllowDrop = true;
            txtTmp_l.AllowDrop = true;
            txtGpu_l.AllowDrop = true;
            txtMdl_l.AllowDrop = true;
            txtClp.AllowDrop = true;
            try
            {
                var conSb = new SQLiteConnectionStringBuilder { DataSource = DatabasePath };
                var con = new SQLiteConnection(conSb.ToString());
                con.Open();
                using (var cmd = new SQLiteCommand(con))
                {
                    cmd.CommandText = $"select * from sum where no=1";
                    using (var reader = cmd.ExecuteReader())
                    {
                        if (reader.Read())
                        {
                            txtCtx_s.Text = reader["ctx"].ToString();
                            txtTmp_s.Text = reader["tmp"].ToString();
                            txtGpu_s.Text = reader["gpu"].ToString();
                            txtMdl_s.Text = reader["mdl"].ToString();
                            txtSys_s.Text = reader["sys"].ToString();
                            txtAnt_s.Text = reader["ant"].ToString();
                            if (txtSys_s.Text=="") txtSys_s.Text = DefSys_s;
                            if (txtAnt_s.Text=="") txtAnt_s.Text = DefAnt;
                        }
                        reader.Close();
                    }
                    cmd.CommandText = $"select * from sd where no = 1";
                    using (var reader = cmd.ExecuteReader())
                    {
                        if (reader.Read())
                        {
                            txtMdl_d.Text = reader["mdl"].ToString();
                            txtVae.Text = reader["vae"].ToString();
                            txtEmb.Text = reader["emb"].ToString();
                        }
                        reader.Close();
                    }

                    cmd.CommandText = $"CREATE TABLE IF NOT EXISTS \"llv\" (" +
                        "\"no\"  INTEGER NOT NULL DEFAULT 0," +
                        "\"tmp\" REAL NOT NULL DEFAULT 0," +
                        "\"gpu\" REAL NOT NULL DEFAULT 0," +
                        "\"ctx\" REAL NOT NULL DEFAULT 0," +
                        "\"mdl\" TEXT," +
                        "\"clp\" TEXT," +
                        "PRIMARY KEY(\"no\"))";
                    cmd.ExecuteNonQuery();

                    cmd.CommandText = $"select count(*) from llv Where no=1";
                    using (var reader = cmd.ExecuteReader())
                    {
                        long reccount = 0;
                        if (reader.Read()) reccount = (long)reader[0];
                        reader.Close();
                        if (reccount==0)
                        {
                            cmd.CommandText = $"insert into llv(tmp,gpu,ctx,mdl,clp) values(0.0,{DefGpu},{DefCtx},'','')";
                            cmd.ExecuteNonQuery();
                        }
                        reader.Close();
                    }
                    cmd.CommandText = $"select * from llv where no=1";
                    using (var reader = cmd.ExecuteReader())
                    {
                        if (reader.Read())
                        {
                            txtCtx_l.Text = reader["ctx"].ToString();
                            txtTmp_l.Text = reader["tmp"].ToString();
                            txtGpu_l.Text = reader["gpu"].ToString();
                            txtMdl_l.Text = reader["mdl"].ToString();
                            txtClp.Text = reader["clp"].ToString();
                            txtSys_l.Text = reader["sys"].ToString();
                            txtAnt_l.Text = reader["ant"].ToString();
                            if (txtSys_l.Text=="") txtSys_l.Text = DefSys_l;
                            if (txtAnt_l.Text=="") txtAnt_l.Text = DefAnt;
                        }
                        reader.Close();
                    }
                }
                con.Close();
                //ピクト表示
                picSm.Visibility = Visibility.Hidden;
                picSd.Visibility = Visibility.Hidden;
                picLv.Visibility = Visibility.Hidden;
                Sm = !await CheckSm(false);
                if (Sm) picSm.Visibility = Visibility.Visible;
                //Stable Diffusion設定チェック
                Sd = !await CheckSd(false);
                if (Sd) picSd.Visibility = Visibility.Visible;
                //Llva設定チェック
                Lv = !await CheckLv(false);
                if (Lv) picLv.Visibility = Visibility.Visible;

            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error18: code={ex.HResult},msg={ex.Message}");
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
            }

        }
        private void InitSettingCom()
        {
            try
            {
                var conSb = new SQLiteConnectionStringBuilder { DataSource = DatabasePath };
                var con = new SQLiteConnection(conSb.ToString());
                con.Open();
                using (var cmd = new SQLiteCommand(con))
                {
                    cmd.CommandText = $"CREATE TABLE IF NOT EXISTS \"com\" (" +
                        "\"no\"  INTEGER NOT NULL DEFAULT 0," +
                        "\"sys\" TEXT," +
                        "\"lng\" TEXT," +
                        "\"vc1\" INTEGER NOT NULL DEFAULT 0," +
                        "\"cmd1\" TEXT," +
                        "\"vc2\" INTEGER NOT NULL DEFAULT 0," +
                        "\"cmd2\" TEXT," +
                        "\"vc3\" INTEGER NOT NULL DEFAULT 0," +
                        "\"cmd3\" TEXT," +
                        "\"vc4\" INTEGER NOT NULL DEFAULT 0," +
                        "\"cmd4\" TEXT," +
                        "\"vc5\" INTEGER NOT NULL DEFAULT 0," +
                        "\"cmd5\" TEXT," +
                        "\"grf\" INTEGER NOT NULL DEFAULT 0," +
                        "\"grk\" TEXT," +
                        "\"grs\" TEXT," +
                        "\"asf\" INTEGER NOT NULL DEFAULT 0," +
                        "\"ask\" TEXT," +
                        "\"ass\" TEXT," +
                        "\"ast\" INTEGER NOT NULL DEFAULT 0," +
                        "\"vtf\" INTEGER NOT NULL DEFAULT 0," +
                        "\"vto\" INTEGER NOT NULL DEFAULT 0," +
                        "\"bnf\" INTEGER NOT NULL DEFAULT 0," +
                        "\"ban\" TEXT," +
                        "\"hwt\" INTEGER NOT NULL DEFAULT 0," +
                        "PRIMARY KEY(\"no\"))";
                    cmd.ExecuteNonQuery();

                    cmd.CommandText = $"select count(*) from com Where no=1";
                    using (var reader = cmd.ExecuteReader())
                    {
                        long reccount = 0;
                        if (reader.Read()) reccount = (long)reader[0];
                        reader.Close();
                        if (reccount==0)
                        {
                            cmd.CommandText = $"insert into com(sys,lng,vc1,cmd1,vc2,cmd2,vc3,cmd3,vc4,cmd4,vc5,cmd5,grf,grk,grs,asf,ask,ass,ast,vtf,vto,bnf,ban,hwt) values('','ja-JP',0,'',0,'',0,'',0,'',0,'',0,'','',0,'','',0,0,0,0,'',0)";
                            cmd.ExecuteNonQuery();
                        }
                        reader.Close();
                    }
                    cmd.CommandText = $"select * from com where no=1";
                    using (var reader = cmd.ExecuteReader())
                    {
                        if (reader.Read())
                        {
                            txtSysOp.Text = reader["sys"].ToString();
                            cboLng.SelectedValue = reader["lng"].ToString() == "" ? DefLng : reader["lng"].ToString();
                            chkVc1.IsChecked = reader["vc1"].ToString() == "1" ? true : false;
                            txtCmd1.Text = reader["cmd1"].ToString();
                            chkVc2.IsChecked = reader["vc2"].ToString() == "1" ? true : false;
                            txtCmd2.Text = reader["cmd2"].ToString();
                            chkVc3.IsChecked = reader["vc3"].ToString() == "1" ? true : false;
                            txtCmd3.Text = reader["cmd3"].ToString();
                            chkGrf.IsChecked = reader["grf"].ToString() == "1" ? true : false;
                            txtGrk.Text = reader["grk"].ToString();
                            txtGrs.Text = reader["grs"].ToString();
                            chkAsf.IsChecked = reader["asf"].ToString() == "1" ? true : false;
                            txtAsk.Text = reader["ask"].ToString();
                            txtAss.Text = reader["ass"].ToString();
                            txtAst.Text = reader["ast"].ToString();
                            chkVtf.IsChecked = reader["vtf"].ToString() == "1" ? true : false;
                            txtVto.Text = reader["vto"].ToString();
                            chkBnf.IsChecked = reader["bnf"].ToString() == "1" ? true : false;
                            txtBan.Text = reader["ban"].ToString();
                            txtHwt.Text = reader["hwt"].ToString();
                        }
                        reader.Close();
                    }
                }
                con.Close();
                if (txtSysOp.Text.Trim() == "") txtSysOp.Text = DefSysOp;
                if (txtCmd1.Text.Trim() == "") txtCmd1.Text = DefCmd1;
                if (txtCmd2.Text.Trim() == "") txtCmd2.Text = DefCmd2;
                if (txtCmd3.Text.Trim() == "") txtCmd3.Text = DefCmd3;
                if (txtGrk.Text.Trim() == "") txtGrk.Text = DefGrk;
                if (txtGrs.Text.Trim() == "") txtGrs.Text = DefGrs;
                if (txtAsk.Text.Trim() == "") txtAsk.Text = DefAsk;
                if (txtAss.Text.Trim() == "") txtAss.Text = DefAss;
                if (txtVto.Text.Trim() == "" || txtVto.Text.Trim() == "0") txtVto.Text = DefVto.ToString();
                if (txtAst.Text.Trim() == "" || txtAst.Text.Trim() == "0") txtAst.Text = DefAst.ToString();
                if (txtBan.Text.Trim() == "") txtBan.Text = DefBan;
                if (txtHwt.Text.Trim() == "" || txtHwt.Text.Trim() == "0") txtHwt.Text = DefHwt.ToString();

                strLng = cboLng.SelectedValue.ToString();
                booGrf = chkGrf.IsChecked.Value;
                strGrk = txtGrk.Text.Trim();
                strGrs = txtGrs.Text.Trim();
                booAsf = chkAsf.IsChecked.Value;
                strAsk = txtAsk.Text.Trim();
                strAss = txtAss.Text.Trim();
                booVtf = chkVtf.IsChecked.Value;
                intVto = 0;
                if (!uint.TryParse(txtVto.Text, out intVto)) intVto = DefVto;
                txtVto.Text = intVto.ToString();
                if (!uint.TryParse(txtAst.Text, out intAst)) intAst = DefAst;
                txtAst.Text = intAst.ToString();
                booBnf = chkBnf.IsChecked.Value;
                strBan = txtBan.Text;
                if (!int.TryParse(txtHwt.Text, out intHwt)) intHwt = DefHwt;
                txtHwt.Text = intHwt.ToString();


                if (chkVc3.IsChecked.Value) picVc3.Visibility = Visibility.Visible;
                else picVc3.Visibility = Visibility.Hidden;
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error19: code={ex.HResult},msg={ex.Message}");
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
            }

        }
        private void AddColumn(string strTable, string strCol, string strType)
        {
            bool booCol = false;
            try
            {
                var conSb = new SQLiteConnectionStringBuilder { DataSource = DatabasePath };
                var con = new SQLiteConnection(conSb.ToString());
                con.Open();
                using (var cmd = new SQLiteCommand(con))
                {
                    cmd.CommandText = $"PRAGMA table_info('{strTable}')";
                    using (var reader = cmd.ExecuteReader())
                    {
                        while (reader.Read())
                        {
                            if(reader["name"].ToString()==strCol) booCol = true;
                        }
                    }
                }
                con.Close();
                if (!booCol)
                {
                    ExcSql($"Alter Table {strTable} ADD COLUMN \"{strCol}\" {strType}", false);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }
        private void CheckColumn()
        {
            //アップデートで追加したデータベースカラムを追加する
            AddColumn("mng", "bot", $"INTEGER DEFAULT 0");
            AddColumn("mng", "tkn", $"TEXT DEFAULT \"\"");
            AddColumn("mng", "cid", $"TEXT DEFAULT \"0\"");
            AddColumn("mng", "usu", $"TEXT DEFAULT \"\"");
            AddColumn("mng", "sml", $"TEXT DEFAULT \"\"");
            AddColumn("mng", "afc", $"TEXT DEFAULT \"\"");
            AddColumn("mng", "skp", $"TEXT DEFAULT \"\"");
            AddColumn("mng", "cnc", $"TEXT DEFAULT \"\"");
            AddColumn("mng", "neg", $"TEXT DEFAULT \"\"");
            AddColumn("mng", "ant", $"TEXT DEFAULT \"\"");
            AddColumn("mng", "frp", $"REAL NOT NULL DEFAULT 0");
            AddColumn("mng", "mxt", $"INTEGER DEFAULT 0");

            AddColumn("sum", "sys", $"TEXT DEFAULT \"\"");
            AddColumn("sum", "ant", $"TEXT DEFAULT \"\"");

            AddColumn("llv", "sys", $"TEXT DEFAULT \"\"");
            AddColumn("llv", "ant", $"TEXT DEFAULT \"\"");

            AddColumn("com", "hwt", $"INTEGER DEFAULT 0");
        }

        private bool ExcSql(string strSql, bool Mb = true)
        {
            try
            {
                var conSb = new SQLiteConnectionStringBuilder { DataSource = DatabasePath };
                var con = new SQLiteConnection(conSb.ToString());
                con.Open();
                using (var cmd = new SQLiteCommand(con))
                {
                    cmd.CommandText = strSql;
                    cmd.ExecuteNonQuery();
                    con.Close();
                }
                return false;
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error20: code={ex.HResult},msg={ex.Message}");
                if (Mb) MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return true;
            }
        }

        private string GetDbValue(string strSql, bool Mb = true) 
        {
            try
            {
                string strRtn = "";
                var conSb = new SQLiteConnectionStringBuilder { DataSource = DatabasePath };
                var con = new SQLiteConnection(conSb.ToString());
                con.Open();
                using (var cmd = new SQLiteCommand(con))
                {
                    cmd.CommandText = strSql;
                    using (var reader = cmd.ExecuteReader())
                    {
                        if (reader.Read())
                        {
                            if (!(reader[0].ToString() is null)) 
                            {
                                strRtn = reader[0].ToString();
                            }
                        }
                    }
                }
                return strRtn;
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error20: code={ex.HResult},msg={ex.Message}");
                if (Mb) MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                return "";
            }
        }

        private async void txtMsg_KeyDown(object sender, System.Windows.Input.KeyEventArgs e)
        {
            try
            {
                if (e.Key == Key.Enter)
                {
                    e.Handled = true;
                    // ユーザーからの質問
                    string strMsg = txtMsg.Text;
                    txtMsg.Text = "";
                    await Chat(strMsg);
                    if (Sd && Sdprompt != "")
                    {
                        SetEnabled_ChatGroup(false);
                        lblInfo.Content = "Now Generating Images...";
                        lblInfo.Visibility = Visibility.Visible;
                        DoEvents();
                        var aimgen = new AimGen();
                        aimgen.ModelPath = txtMdl_d.Text;
                        aimgen.VaePath = txtVae.Text;
                        aimgen.EmbPath = txtEmb.Text;
                        picPrv.ImageSource = (BitmapImage)aimgen.AimGenRun(Sdprompt);
                        if (!OpenMenu.IsChecked.Value) //サイドが閉まっていたら勝手に開ける
                        {
                            OpenMenu.IsChecked = true;
                            OpenMenu_Click(sender, e);
                        }
                        aimgen = null;
                        lblInfo.Visibility = Visibility.Hidden;
                        SetEnabled_ChatGroup(true);
                        Sdprompt = "";
                    }
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error32: code={ex.HResult},msg={ex.Message}");
                lblInfo.Visibility = Visibility.Hidden;
                SetEnabled_ChatGroup(true);
            }
        }

        private string OpenFile(string strFolder, string strTitle, string strInitFile, string strFilter)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.FileName = strInitFile;
            dialog.InitialDirectory = strFolder;
            dialog.FilterIndex = 2;
            dialog.Title = strTitle;
            dialog.RestoreDirectory = true;
            dialog.CheckFileExists = true;
            dialog.CheckPathExists = true;
            dialog.Filter = strFilter;
            if (dialog.ShowDialog() == true) return (dialog.FileName);
            return ("");
        }
        private void btnMdl_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (txtMdl.Text.ToString() != null) strFolder = System.IO.Path.GetDirectoryName(txtMdl.Text.ToString());
            string strFilter = $"model file|*.gguf;*.bin;*.safetensors";
            string strRtn = OpenFile(strFolder, "Open Model File", txtMdl.Text.ToString(), strFilter);
            if (strRtn != "") txtMdl.Text = strRtn;
        }

        private void btnCvo_Click(object sender, RoutedEventArgs e)
        {
            CevioAI($"おはよう、こんにちは、こんばんは", cboCvo.SelectedValue.ToString());
        }

        private void btnVvx_Click(object sender, RoutedEventArgs e)
        {
            if (uint.Parse(cboVvx.SelectedValue.ToString()) != intVvx)
            {
                intVvx = uint.Parse(cboVvx.SelectedValue.ToString());
                InitVoicevox(intVvx);
            }
            Voicevox($"おはよう、こんにちは、こんばんは", uint.Parse(cboVvx.SelectedValue.ToString()));
        }
        private async void btnNew_Click(object sender, RoutedEventArgs e)
        {
            if (await CheckEd()) return;

            if (await MessageBox_Show("Add a new record. Are you sure?", this.Title, MessageBoxButton.YesNo, MessageBoxImage.Question) == MessageBoxResult.No) return;
            //sql編集
            string strUsu = ((BitmapImage)picUsu.ImageSource).UriSource.OriginalString;
            if (strUsu != "") if (!File.Exists(strUsu)) strUsu = "";
            string strSml = ((BitmapImage)picSml.ImageSource).UriSource.OriginalString;
            if (strSml != "") if (!File.Exists(strSml)) strSml = "";
            string strAfc = ((BitmapImage)picAfc.ImageSource).UriSource.OriginalString;
            if (strAfc != "") if (!File.Exists(strAfc)) strAfc = "";
            string strSkp = ((BitmapImage)picSkp.ImageSource).UriSource.OriginalString;
            if (strSkp != "") if (!File.Exists(strSkp)) strSkp = "";
            string strCnc = ((BitmapImage)picCnc.ImageSource).UriSource.OriginalString;
            if (strCnc != "") if (!File.Exists(strCnc)) strCnc = "";
            string strNeg = ((BitmapImage)picNeg.ImageSource).UriSource.OriginalString;
            if (strNeg != "") if (!File.Exists(strNeg)) strNeg = "";
            string strSql = "insert into mng(tmp,gpu,ctx,sys,nam,syt,cvo,vvx,mdl,ant,frp,mxt,bot,tkn,cid,usu,sml,afc,skp,cnc,neg) values(" +
                            $"{txtTmp.Text}," +
                            $"{txtGpu.Text}," +
                            $"{txtCtx.Text}," +
                            $"'{txtSys.Text}'," +
                            $"'{txtNam.Text}'," +
                            $"{cboSyt.SelectedValue}," +
                            $"'{cboCvo.SelectedValue}'," +
                            $"{cboVvx.SelectedValue}," +
                            $"'{txtMdl.Text}'," +
                            $"'{txtAnt.Text}'," +
                            $"{txtFrp.Text}," +
                            $"{txtMxt.Text}," +
                            $"{(chkBot.IsChecked.Value ? 1 : 0)}," +
                            $"'{txtTkn.Text}'," +
                            $"'{txtCid.Text}'," +
                            $"'{strUsu}'," +
                            $"'{strSml}'," +
                            $"'{strAfc}'," +
                            $"'{strSkp}'," +
                            $"'{strCnc}'," +
                            $"'{strNeg}')";
            ExcSql(strSql);
            ContentSelector.SelectedIndex = 0;
            Menu_Button_Click();
        }

        private async void btnUpd_Click(object sender, RoutedEventArgs e)
        {
            if (chkDel.IsChecked.Value)
            {
                if (await MessageBox_Show("Delete record. Are you sure?", this.Title, MessageBoxButton.YesNo, MessageBoxImage.Question) == MessageBoxResult.No) return;
                string strSql = $"delete from mng where no={cboCht.SelectedValue}";
                if (ExcSql(strSql)) return;
                strSql = $"drop table ch{cboCht.SelectedValue}";
                ExcSql(strSql, false);
            }
            else
            {
                string strUsu = ((BitmapImage)picUsu.ImageSource).UriSource.OriginalString;
                if (strUsu != "") if (!File.Exists(strUsu)) strUsu = "";
                string strSml = ((BitmapImage)picSml.ImageSource).UriSource.OriginalString;
                if (strSml != "") if (!File.Exists(strSml)) strSml = "";
                string strAfc = ((BitmapImage)picAfc.ImageSource).UriSource.OriginalString;
                if (strAfc != "") if (!File.Exists(strAfc)) strAfc = "";
                string strSkp = ((BitmapImage)picSkp.ImageSource).UriSource.OriginalString;
                if (strSkp != "") if (!File.Exists(strSkp)) strSkp = "";
                string strCnc = ((BitmapImage)picCnc.ImageSource).UriSource.OriginalString;
                if (strCnc != "") if (!File.Exists(strCnc)) strCnc = "";
                string strNeg = ((BitmapImage)picNeg.ImageSource).UriSource.OriginalString;
                if (strNeg != "") if (!File.Exists(strNeg)) strNeg = "";

                string strTable = $"ch{cboCht.SelectedValue}";
                if (await CheckEd()) return;
                if (await MessageBox_Show("Update record. Are you sure?", this.Title, MessageBoxButton.YesNo, MessageBoxImage.Question) == MessageBoxResult.No) return;
                string strSql = "update mng set " +
                                $"tmp={txtTmp.Text}," +
                                $"gpu={txtGpu.Text}," +
                                $"ctx={txtCtx.Text}," +
                                $"sys='{txtSys.Text}'," +
                                $"nam='{txtNam.Text}'," +
                                $"syt={cboSyt.SelectedValue}," +
                                $"cvo='{cboCvo.SelectedValue}'," +
                                $"vvx={cboVvx.SelectedValue}," +
                                $"mdl='{txtMdl.Text}'," +
                                $"ant='{txtAnt.Text}'," +
                                $"frp={txtFrp.Text}," +
                                $"mxt={txtMxt.Text}," +
                                $"bot={(chkBot.IsChecked.Value ? 1 : 0)}," +
                                $"tkn='{txtTkn.Text}'," +
                                $"cid='{txtCid.Text}'," +
                                $"usu='{strUsu}'," +
                                $"sml='{strSml}'," +
                                $"afc='{strAfc}'," +
                                $"skp='{strSkp}'," +
                                $"cnc='{strCnc}'," +
                                $"neg='{strNeg}'" +
                                $" where no={cboCht.SelectedValue}";
                ExcSql(strSql);
            }
            ContentSelector.SelectedIndex = 0;
            Menu_Button_Click();
        }

        private async void btnDh_Click(object sender, EventArgs e)
        {
            if (await MessageBox_Show("Are you sure you want to delete your chat history?", this.Title, MessageBoxButton.YesNo, MessageBoxImage.Question) == MessageBoxResult.No) return;
            string strSql = $"drop table ch{cboCht.SelectedValue}";
            ExcSql(strSql, false);
            ContentSelector.SelectedIndex = 0;
            Menu_Button_Click();
        }


        private void btnMdl_s_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (txtMdl_s.Text.ToString() != null) strFolder = Path.GetDirectoryName(txtMdl_s.Text.ToString());
            string strFilter = $"model file|*.gguf;*.bin;*.safetensors;";
            string strRtn = OpenFile(strFolder: strFolder, "Open Model File", txtMdl_s.Text.ToString(), strFilter);
            if (strRtn != "") txtMdl_s.Text = strRtn;
        }
        private void btnMdl_d_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (txtMdl_d.Text.ToString() != null) strFolder = Path.GetDirectoryName(txtMdl_d.Text.ToString());
            string strFilter = $"model file|*.gguf;*.bin;*.safetensors;";
            string strRtn = OpenFile(strFolder: strFolder, "Open Model File", txtMdl_d.Text.ToString(), strFilter);
            if (strRtn != "") txtMdl_d.Text = strRtn;
        }
        private void btnVae_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (txtVae.Text.ToString() != null) strFolder = Path.GetDirectoryName(txtVae.Text.ToString());
            string strFilter = $"model file|*.gguf;*.bin;*.safetensors;*.pt;";
            string strRtn = OpenFile(strFolder, "Open Vae Model File", txtVae.Text.ToString(), strFilter);
            if (strRtn != "") txtVae.Text = strRtn;
        }
        private void btnEmb_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (txtEmb.Text.ToString() != null) strFolder = Path.GetDirectoryName(txtEmb.Text.ToString());
            string strFilter = $"model file|*.gguf;*.bin;*.safetensors;*.pt;";
            string strRtn = OpenFile(strFolder, "Open Emb Model File", txtEmb.Text.ToString(), strFilter);
            if (strRtn != "") txtEmb.Text = strRtn;
        }
        private void btnMdl_l_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (txtMdl_l.Text.ToString() != null) strFolder = Path.GetDirectoryName(txtMdl_l.Text.ToString());
            string strFilter = $"model file|*.gguf;*.bin;*.safetensors;";
            string strRtn = OpenFile(strFolder: strFolder, "Open Model File", txtMdl_l.Text.ToString(), strFilter);
            if (strRtn != "") txtMdl_l.Text = strRtn;
        }
        private void btnClp_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (txtClp.Text.ToString() != null) strFolder = Path.GetDirectoryName(txtClp.Text.ToString());
            string strFilter = $"model file|*.gguf;*.bin;*.safetensors;";
            string strRtn = OpenFile(strFolder: strFolder, "Open Clip Model File", txtClp.Text.ToString(), strFilter);
            if (strRtn != "") txtClp.Text = strRtn;
        }
        private async void btnUpd2_Click(object sender, RoutedEventArgs e)
        {
            //Summary Check
            if (await CheckSm()) return;
            //Stable diffusion Check
            if (await CheckSd()) return;
            //Llava Check
            if (await CheckLv()) return;
            //Update
            if (await MessageBox_Show("Update record. Are you sure?", this.Title, MessageBoxButton.YesNo, MessageBoxImage.Question) == MessageBoxResult.No) return;
            string strSql = "";
            strSql = "update sum set " +
                        $"sys='{txtSys_s.Text}'," +
                        $"tmp={txtTmp_s.Text}," +
                        $"gpu={txtGpu_s.Text}," +
                        $"ctx={txtCtx_s.Text}," +
                        $"mdl='{txtMdl_s.Text}'," +
                        $"ant='{txtAnt_s.Text}'" +
                        $" where no=1";
            if (ExcSql(strSql)) return;

            strSql = "update sd set " +
                        $"mdl='{txtMdl_d.Text}'," +
                        $"vae='{txtVae.Text}'," +
                        $"emb='{txtEmb.Text}'" +
                        $" where no = 1";
            if (ExcSql(strSql)) return;

            strSql = "update llv set " +
                        $"sys='{txtSys_l.Text}'," +
                        $"tmp={txtTmp_l.Text}," +
                        $"gpu={txtGpu_l.Text}," +
                        $"ctx={txtCtx_l.Text}," +
                        $"ant='{txtAnt_l.Text}'," +
                        $"mdl='{txtMdl_l.Text}'," +
                        $"clp='{txtClp.Text}'" +
                        $" where no=1";
            ExcSql(strSql);

            ContentSelector.SelectedIndex = 0;
            Menu_Button_Click();
        }
        private async void btnUpd3_Click(object sender, RoutedEventArgs e)
        {
            //Common Check
            CheckCom();
            //Update
            if (await MessageBox_Show("Update record. Are you sure?", this.Title, MessageBoxButton.YesNo, MessageBoxImage.Question) == MessageBoxResult.No) return;
            string strSql = "";
            int intVc1 = chkVc1.IsChecked.Value ? 1 : 0;
            int intVc2 = chkVc2.IsChecked.Value ? 1 : 0;
            int intVc3 = chkVc3.IsChecked.Value ? 1 : 0;
            int intGrf = chkGrf.IsChecked.Value ? 1 : 0;
            int intAsf = chkAsf.IsChecked.Value ? 1 : 0;
            int intVtf = chkVtf.IsChecked.Value ? 1 : 0;
            int intBnf = chkBnf.IsChecked.Value ? 1 : 0;
            strSql = "update com set " +
                        $"sys='{txtSysOp.Text}'," +
                        $"lng='{cboLng.SelectedValue.ToString()}'," +
                        $"vc1={intVc1}," +
                        $"cmd1='{txtCmd1.Text}'," +
                        $"vc2={intVc2}," +
                        $"cmd2='{txtCmd2.Text}'," +
                        $"vc3={intVc3}," +
                        $"cmd3='{txtCmd3.Text}'," +
                        $"grf={intGrf}," +
                        $"grk='{txtGrk.Text}'," +
                        $"grs='{txtGrs.Text}'," +
                        $"asf={intAsf}," +
                        $"ask='{txtAsk.Text}'," +
                        $"ass='{txtAss.Text}'," +
                        $"ast={txtAst.Text}," +
                        $"vtf={intVtf}," +
                        $"vto='{txtVto.Text}'," +
                        $"bnf={intBnf}," +
                        $"ban='{txtBan.Text}'," +
                        $"hwt={txtHwt.Text}" +
                        $" where no=1";
            if (ExcSql(strSql)) return;

            if (chkVc3.IsChecked.Value) picVc3.Visibility = Visibility.Visible;
            else picVc3.Visibility = Visibility.Hidden;

            AwakeWord = txtCmd1.Text.Split(",");
            //AsleepWord = txtCmd2.Text.Split(",");
            AsleepWord = txtCmd2.Text.Replace(",", "|");
            AendWord = txtCmd3.Text.Split(",");
            Choices awake = new Choices(AwakeWord);
            GrammarBuilder gb1 = new GrammarBuilder(awake);
            recognizer1.LoadGrammar(new System.Speech.Recognition.Grammar(gb1));

            //Choices asleep = new Choices(AsleepWord);
            //GrammarBuilder gb2 = new GrammarBuilder(asleep);
            //recognizer2.LoadGrammar(new System.Speech.Recognition.Grammar(gb2));

            Choices aend = new Choices(AendWord);
            GrammarBuilder gb3 = new GrammarBuilder(aend);
            recognizer3.LoadGrammar(new System.Speech.Recognition.Grammar(gb3));

            strLng = cboLng.SelectedValue.ToString();
            if (chkVc1.IsChecked.Value && !booVc1)
            {
                //Speech Recognizer1開始
                recognizer1.SetInputToDefaultAudioDevice();
                recognizer1.RecognizeAsync(RecognizeMode.Multiple);
                booVc1 = true;
            }
            if (chkVc2.IsChecked.Value && !booVc2)
            {
                //Speech Recognizer2開始
                //recognizer2.SetInputToDefaultAudioDevice();
                //recognizer2.RecognizeAsync(RecognizeMode.Multiple);
                booVc2 = true;
            }
            if (chkVc3.IsChecked.Value && !booVc3)
            {
                //Speech Recognizer3開始
                recognizer3.SetInputToDefaultAudioDevice();
                recognizer3.RecognizeAsync(RecognizeMode.Multiple);
                booVc3 = true;
            }
            if (!chkVc1.IsChecked.Value && booVc1)
            {
                //Speech Recognizer終了
                recognizer1.RecognizeAsyncStop();
                booVc1 = false;
            }
            if (!chkVc2.IsChecked.Value && booVc2)
            {
                //Speech Recognizer2終了
                //recognizer2.RecognizeAsyncStop();
                booVc2 = false;
            }
            if (!chkVc3.IsChecked.Value && booVc3)
            {
                //Speech Recognizer3終了
                recognizer3.RecognizeAsyncStop();
                booVc3 = false;
            }

            ContentSelector.SelectedIndex = 0;
            Menu_Button_Click();
        }

        private void Window_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            if (e.ButtonState == MouseButtonState.Pressed)
                this.DragMove();
        }

        private void btnMin_Click(object sender, RoutedEventArgs e)
        {
            this.WindowState = WindowState.Minimized;
        }

        private void btnMax_Click(object sender, RoutedEventArgs e)
        {
            if (this.WindowState == WindowState.Normal)
                this.WindowState = WindowState.Maximized;
            else
                this.WindowState = WindowState.Normal;
        }

        private void btnCls_Click(object sender, RoutedEventArgs e)
        {
            System.Windows.Application.Current.Shutdown();
        }

        private async void timer_Tick(object sender, System.Timers.ElapsedEventArgs e)
        {
            try
            {
                if(recognizer != null) Debug.WriteLine($"rs3={recognizer.State}");
                timerCnt++;
                //AIから話しかける仕組み
                if (timerCnt == intAst && booAsf)
                {
                    Random rTalk = new Random();
                    if (rTalk.Next(0, 1) == 0) 
                    {
                        await Chat(strAsk);
                    }
                }
                if (booMic)
                {
                    if (booVtf && timerCnt > intVto) 
                    {
                        Dispatcher.Invoke((Action)(() =>
                        {
                            chkMic.IsChecked = false;
                            chkMic_Change();
                        }));
                        return;
                    }
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error22: code={ex.HResult},msg={ex.Message}");
            }
        }

        private void chkMic_Click(object sender, RoutedEventArgs e)
        {
            chkMic_Change();
        }

        private async void chkMic_Change() 
        {
            try
            {
                if (chkMic.IsChecked.Value)
                {
                    booMic = true;
                    await StartRecognizer();
                    timerCnt = 0;
                    timer.Start();
                    picVc1.Visibility = Visibility.Hidden;
                    picVc3.Visibility = Visibility.Hidden;
                    picVto.Visibility = Visibility.Hidden;
                    if (chkVc2.IsChecked.Value) picVc2.Visibility = Visibility.Visible;
                    if (chkVtf.IsChecked.Value) picVto.Visibility = Visibility.Visible;
                    if (!chkSpk.IsChecked.Value)
                    {
                        chkSpk.IsChecked = true;
                        chkSpk_Change();
                    } 
                }
                else
                {
                    booMic = false;
                    await StopRecognizer();
                    timer.Stop();
                    if (chkVc1.IsChecked.Value) picVc1.Visibility= Visibility.Visible;
                    if (chkVc3.IsChecked.Value) picVc3.Visibility= Visibility.Visible;
                    picVc2.Visibility = Visibility.Hidden;
                    picVto.Visibility = Visibility.Hidden;
                    if (chkSpk.IsChecked.Value)
                    {
                        chkSpk.IsChecked = false;
                        chkSpk_Change();
                    }
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error23: code={ex.HResult},msg={ex.Message}");
                if (ex.HResult == -2147199735) MessageBox.Show("Have you enabled the \"online speech recognition\" in Windows settings under Start > Settings > Privacy > Speech? And have you enabled the microphone under the app capabilites?", this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
                else MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        private void chkSpk_Change() 
        {
            if (chkSpk.IsChecked.Value)
            {
                booSpk = true;
            }
            else
            {
                booSpk = false;
            }
        }

        private void btnUsu_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (((BitmapImage)picUsu.ImageSource).UriSource.OriginalString != "") strFolder = Path.GetDirectoryName(((BitmapImage)picUsu.ImageSource).UriSource.OriginalString);
            string strFilter = $"Image file|*.jpg;*.jpeg;*.gif;*.bmp;*.wmf;*.png";
            string strRtn = OpenFile(strFolder, "Open Image File", ((BitmapImage)picUsu.ImageSource).UriSource.OriginalString, strFilter);
            if (strRtn != "") picUsu.ImageSource = new BitmapImage(new Uri(strRtn, UriKind.Relative));
        }

        private void btnSml_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (((BitmapImage)picSml.ImageSource).UriSource.OriginalString != "") strFolder = Path.GetDirectoryName(((BitmapImage)picSml.ImageSource).UriSource.OriginalString);
            string strFilter = $"Image file|*.jpg;*.jpeg;*.gif;*.bmp;*.wmf;*.png";
            string strRtn = OpenFile(strFolder, "Open Image File", ((BitmapImage)picSml.ImageSource).UriSource.OriginalString, strFilter);
            if (strRtn != "") picSml.ImageSource = new BitmapImage(new Uri(strRtn, UriKind.Relative));
        }

        private void btnAfc_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (((BitmapImage)picAfc.ImageSource).UriSource.OriginalString != "") strFolder = Path.GetDirectoryName(((BitmapImage)picAfc.ImageSource).UriSource.OriginalString);
            string strFilter = $"Image file|*.jpg;*.jpeg;*.gif;*.bmp;*.wmf;*.png";
            string strRtn = OpenFile(strFolder, "Open Image File", ((BitmapImage)picAfc.ImageSource).UriSource.OriginalString, strFilter);
            if (strRtn != "") picAfc.ImageSource = new BitmapImage(new Uri(strRtn, UriKind.Relative));
        }

        private void btnSkp_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (((BitmapImage)picSkp.ImageSource).UriSource.OriginalString != "") strFolder = Path.GetDirectoryName(((BitmapImage)picSkp.ImageSource).UriSource.OriginalString);
            string strFilter = $"Image file|*.jpg;*.jpeg;*.gif;*.bmp;*.wmf;*.png";
            string strRtn = OpenFile(strFolder, "Open Image File", ((BitmapImage)picSkp.ImageSource).UriSource.OriginalString, strFilter);
            if (strRtn != "") picSkp.ImageSource = new BitmapImage(new Uri(strRtn, UriKind.Relative));
        }

        private void btnCnc_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (((BitmapImage)picCnc.ImageSource).UriSource.OriginalString != "") strFolder = Path.GetDirectoryName(((BitmapImage)picCnc.ImageSource).UriSource.OriginalString);
            string strFilter = $"Image file|*.jpg;*.jpeg;*.gif;*.bmp;*.wmf;*.png";
            string strRtn = OpenFile(strFolder, "Open Image File", ((BitmapImage)picCnc.ImageSource).UriSource.OriginalString, strFilter);
            if (strRtn != "") picCnc.ImageSource = new BitmapImage(new Uri(strRtn, UriKind.Relative));
        }

        private void btnNeg_Click(object sender, RoutedEventArgs e)
        {
            string strFolder = "";
            if (((BitmapImage)picNeg.ImageSource).UriSource.OriginalString != "") strFolder = Path.GetDirectoryName(((BitmapImage)picNeg.ImageSource).UriSource.OriginalString);
            string strFilter = $"Image file|*.jpg;*.jpeg;*.gif;*.bmp;*.wmf;*.png";
            string strRtn = OpenFile(strFolder, "Open Image File", ((BitmapImage)picNeg.ImageSource).UriSource.OriginalString, strFilter);
            if (strRtn != "") picNeg.ImageSource = new BitmapImage(new Uri(strRtn, UriKind.Relative));
        }

        private void Picture_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop)) e.Effects = DragDropEffects.Copy;
        }

        private void picUsu_Drop(object sender, DragEventArgs e)
        {
            try
            {
                if (e.Data != null)
                {
                    string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                    System.Drawing.Image img = System.Drawing.Image.FromFile(strFiles[0]);
                    img.Dispose();
                    picUsu.ImageSource = new BitmapImage(new Uri(strFiles[0], UriKind.Relative));
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error24: code={ex.HResult},msg={ex.Message}");
            }
        }

        private void picSml_Drop(object sender, DragEventArgs e)
        {
            try
            {
                if (e.Data != null)
                {
                    string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                    System.Drawing.Image img = System.Drawing.Image.FromFile(strFiles[0]);
                    img.Dispose();
                    picSml.ImageSource = new BitmapImage(new Uri(strFiles[0], UriKind.Relative));
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error25: code={ex.HResult},msg={ex.Message}");
            }
        }

        private void picAfc_Drop(object sender, DragEventArgs e)
        {
            try
            {
                if (e.Data != null)
                {
                    string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                    System.Drawing.Image img = System.Drawing.Image.FromFile(strFiles[0]);
                    img.Dispose();
                    picAfc.ImageSource = new BitmapImage(new Uri(strFiles[0], UriKind.Relative));
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error26: code={ex.HResult},msg={ex.Message}");
            }
        }

        private void picSkp_Drop(object sender, DragEventArgs e)
        {
            try
            {
                if (e.Data != null)
                {
                    string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                    System.Drawing.Image img = System.Drawing.Image.FromFile(strFiles[0]);
                    img.Dispose();
                    picSkp.ImageSource = new BitmapImage(new Uri(strFiles[0], UriKind.Relative));
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error27: code={ex.HResult},msg={ex.Message}");
            }
        }

        private void picCnc_Drop(object sender, DragEventArgs e)
        {
            try
            {
                if (e.Data != null)
                {
                    string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                    System.Drawing.Image img = System.Drawing.Image.FromFile(strFiles[0]);
                    img.Dispose();
                    picCnc.ImageSource = new BitmapImage(new Uri(strFiles[0], UriKind.Relative));
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error28: code={ex.HResult},msg={ex.Message}");
            }
        }

        private void picNeg_Drop(object sender, DragEventArgs e)
        {
            try
            {
                if (e.Data != null)
                {
                    string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                    System.Drawing.Image img = System.Drawing.Image.FromFile(strFiles[0]);
                    img.Dispose();
                    picNeg.ImageSource = new BitmapImage(new Uri(strFiles[0], UriKind.Relative));
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error29: code={ex.HResult},msg={ex.Message}");
            }
        }

        private void btnPrv_Click(object sender, RoutedEventArgs e)
        {
            if (picPrv.ImageSource != null)
            {
                string rtn = SaveFile("", this.Title, "");
                if (rtn != "")
                {
                    using (var fileStream = new FileStream(rtn, FileMode.Create))
                    {
                        BitmapEncoder encoder = new PngBitmapEncoder();
                        encoder.Frames.Add(BitmapFrame.Create(picPrv.ImageSource as BitmapImage));
                        encoder.Save(fileStream);
                    }
                }
            }
        }
        private string SaveFile(string strFolder, string strTitle, string strInitFile)
        {
            SaveFileDialog dialog = new SaveFileDialog();
            dialog.FileName = strInitFile;
            dialog.InitialDirectory = strFolder;
            dialog.FilterIndex = 2;
            dialog.Title = strTitle;
            dialog.RestoreDirectory = true;
            dialog.Filter = $"model png|*.png;";
            if (dialog.ShowDialog() == true) return (dialog.FileName);
            return ("");
        }
        private void dvwMsg_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            try
            {
                if (dvwMsg.SelectedItem != null)
                {
                    if (((TextBlock)dvwMsg.Columns[0].GetCellContent(dvwMsg.SelectedItem)).Text == strAI)
                    {
                        string strMsg = ((TextBlock)dvwMsg.Columns[1].GetCellContent(dvwMsg.SelectedItem)).Text;

                        //画像生成キーワード探索
                        if (strMsg.IndexOf("[")  != -1 && Sd)
                        {
                            var rgxRtn = new Regex(@"\[(.+?)\]").Matches(strMsg);
                            if (rgxRtn.Count > 0)
                            {
                                Sdprompt = rgxRtn[0].Value.Replace("[", "").Replace("]", "").Trim();
                                if (Sdprompt != "")
                                {
                                    DoEvents();
                                    SetEnabled_ChatGroup(false);
                                    lblInfo.Content = "Now Generating Images...";
                                    lblInfo.Visibility = Visibility.Visible;
                                    DoEvents();
                                    var aimgen = new AimGen();
                                    aimgen.ModelPath = txtMdl_d.Text;
                                    aimgen.VaePath = txtVae.Text;
                                    aimgen.EmbPath = txtEmb.Text;
                                    picPrv.ImageSource = (BitmapImage)aimgen.AimGenRun(Sdprompt);
                                    if (!OpenMenu.IsChecked.Value) //サイドが閉まっていたら勝手に開ける
                                    {
                                        OpenMenu.IsChecked = true;
                                        OpenMenu_Click(sender, e);
                                    }
                                    aimgen = null;
                                    lblInfo.Visibility = Visibility.Hidden;
                                    SetEnabled_ChatGroup(true);
                                    Sdprompt = "";
                                }
                            }
                        }
                        else
                        {
                            picEmt.Source = SelectEmtImg(SearchEmotion(strMsg));
                            DoEvents();
                            if (!Wt)
                            {
                                Wt = true;
                                SpeechSynthesis(strMsg); //音声ソフト実行
                                Thread.Sleep(3000);
                                Wt = false;
                            }
                        }
                    }
                }

            }
            catch (Exception ex) 
            {
                Debug.WriteLine($"Error40: code={ex.HResult},msg={ex.Message}");
            }

        }

        private void dvwMsg_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop)) e.Effects = DragDropEffects.Copy;
        }

        private async void dvwMsg_Drop(object sender, DragEventArgs e)
        {
            try
            {
                if (e.Data != null)
                {
                    string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                    var img = new BitmapImage(new Uri(strFiles[0], UriKind.Relative));
                    img = null;
                    if (Lv)
                    {
                        DoEvents();
                        SetEnabled_ChatGroup(false);
                        lblInfo.Content = "Now Analyzing Images...";
                        lblInfo.Visibility = Visibility.Visible;
                        DoEvents();
                        var llv = new Llava();
                        llv.ModelPath = txtMdl_l.Text;
                        llv.ClipPath = txtClp.Text;
                        llv.ContextSize = uint.Parse(txtCtx_l.Text);
                        llv.GpuLayerCount = int.Parse(txtGpu_l.Text);
                        llv.Temperature = float.Parse(txtTmp_l.Text);
                        llv.SystemPrompt = txtSys.Text;
                        llv.Prompt = txtSys_l.Text;
                        llv.AntiPrompt = txtAnt_l.Text;
                        string strMsg = await llv.Run(strFiles[0]);
                        if (strMsg != "")
                            LlavaChat(txtAnt_l.Text, strMsg);
                        lblInfo.Visibility = Visibility.Hidden;
                        SetEnabled_ChatGroup(true);
                        llv = null;
                    }
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error30: code={ex.HResult},msg={ex.Message}");
                lblInfo.Visibility = Visibility.Hidden;
                SetEnabled_ChatGroup(true);
            }
        }

        private void SetEnabled_ChatGroup(bool booIsEnabled)
        {
            btnEject.IsEnabled = booIsEnabled;
            dvwMsg.IsEnabled = booIsEnabled;
            txtMsg.IsEnabled = booIsEnabled;
            chkMic.IsEnabled = booIsEnabled;
            chkSpk.IsEnabled = booIsEnabled;
        }

        private void LlavaChat(string strUserInput, string strAiInput)
        {
            try
            {
                if (!Wt)
                {
                    Wt = true;
                    chtHis.AddMessage(AuthorRole.User, strUserInput);
                    WriteHistory(AuthorRole.User, strUserInput);
                    Dispatcher.Invoke(dvwMsg_Refresh);
                    // 回答の表示
                    string strSndmsg = EditAiMsg(strAiInput);
                    chtHis.AddMessage(AuthorRole.Assistant, strAiInput);
                    WriteHistory(AuthorRole.Assistant, strSndmsg);
                    Dispatcher.Invoke(dvwMsg_Refresh);
                    if (booMic)
                    {
                        SpeechSynthesis(strSndmsg); //音声ソフト実行
                        Thread.Sleep(3000);
                    }
                    Wt = false;
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error31: code={ex.HResult},msg={ex.Message}");
                MessageBox.Show(ex.Message, this.Title, MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        private void txtMsg_GotFocus(object sender, RoutedEventArgs e)
        {
            txtMsg.SelectAll();
        }

        private void txtNam_GotFocus(object sender, RoutedEventArgs e)
        {
            txtNam.SelectAll();
        }

        private void txtSys_GotFocus(object sender, RoutedEventArgs e)
        {
            txtSys.SelectAll();
        }

        private void txtCtx_GotFocus(object sender, RoutedEventArgs e)
        {
            txtCtx.SelectAll();
        }

        private void txtTmp_GotFocus(object sender, RoutedEventArgs e)
        {
            txtTmp.SelectAll();
        }

        private void txtGpu_GotFocus(object sender, RoutedEventArgs e)
        {
            txtGpu.SelectAll();
        }

        private void txtMdl_GotFocus(object sender, RoutedEventArgs e)
        {
            txtMdl.SelectAll();
        }

        private void txtAnt_GotFocus(object sender, RoutedEventArgs e)
        {
            txtAnt.SelectAll();
        }

        private void txtTkn_GotFocus(object sender, RoutedEventArgs e)
        {
            txtTkn.SelectAll();
        }

        private void txtCid_GotFocus(object sender, RoutedEventArgs e)
        {
            txtCid.SelectAll();
        }

        private void txtMdl_d_GotFocus(object sender, RoutedEventArgs e)
        {
            txtMdl_d.SelectAll();
        }

        private void txtVae_GotFocus(object sender, RoutedEventArgs e)
        {
            txtVae.SelectAll();
        }

        private void txtEmb_GotFocus(object sender, RoutedEventArgs e)
        {
            txtEmb.SelectAll();
        }
        private void txtSys_l_GotFocus(object sender, RoutedEventArgs e)
        {
            txtSys_l.SelectAll();
        }

        private void txtCtx_l_GotFocus(object sender, RoutedEventArgs e)
        {
            txtCtx_l.SelectAll();
        }

        private void txtTmp_l_GotFocus(object sender, RoutedEventArgs e)
        {
            txtTmp_l.SelectAll();
        }

        private void txtGpu_l_GotFocus(object sender, RoutedEventArgs e)
        {
            txtGpu_l.SelectAll();
        }
        private void txtAnt_l_GotFocus(object sender, RoutedEventArgs e)
        {
            txtAnt_l.SelectAll();
        }

        private void txtMdl_l_GotFocus(object sender, RoutedEventArgs e)
        {
            txtMdl_l.SelectAll();
        }

        private void txtClp_GotFocus(object sender, RoutedEventArgs e)
        {
            txtClp.SelectAll();
        }
        private void txtSys_s_GotFocus(object sender, RoutedEventArgs e)
        {
            txtSys_s.SelectAll();
        }

        private void txtCtx_s_GotFocus(object sender, RoutedEventArgs e)
        {
            txtCtx_s.SelectAll();
        }

        private void txtTmp_s_GotFocus(object sender, RoutedEventArgs e)
        {
            txtTmp_s.SelectAll();
        }

        private void txtGpu_s_GotFocus(object sender, RoutedEventArgs e)
        {
            txtGpu_s.SelectAll();
        }
        private void txtAnt_s_GotFocus(object sender, RoutedEventArgs e)
        {
            txtAnt_s.SelectAll();
        }

        private void txtMdl_s_GotFocus(object sender, RoutedEventArgs e)
        {
            txtMdl_s.SelectAll();
        }
        private void txtSysOp_GotFocus(object sender, RoutedEventArgs e)
        {
            txtSysOp.SelectAll();
        }
        private void txtCmd1_GotFocus(object sender, RoutedEventArgs e)
        {
            txtCmd1.SelectAll();
        }
        private void txtCmd2_GotFocus(object sender, RoutedEventArgs e)
        {
            txtCmd2.SelectAll();
        }
        private void txtCmd3_GotFocus(object sender, RoutedEventArgs e)
        {
            txtCmd3.SelectAll();
        }
        private void txtTim_GotFocus(object sender, RoutedEventArgs e)
        {
            txtVto.SelectAll();
        }
        private void txtGrk_GotFocus(object sender, RoutedEventArgs e)
        {
            txtGrk.SelectAll();
        }
        private void txtGrs_GotFocus(object sender, RoutedEventArgs e)
        {
            txtGrs.SelectAll();
        }
        private void txtAsk_GotFocus(object sender, RoutedEventArgs e)
        {
            txtAsk.SelectAll();
        }
        private void txtAss_GotFocus(object sender, RoutedEventArgs e)
        {
            txtAss.SelectAll();
        }
        private void txtAst_GotFocus(object sender, RoutedEventArgs e)
        {
            txtAst.SelectAll();
        }
        private void chkMod_Checked(object sender, RoutedEventArgs e)
        {
            SetBaseColors();
        }
        private void txtModel_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop)) e.Effects = DragDropEffects.Copy;
        }

        private void txtMdl_Drop(object sender, DragEventArgs e)
        {
            if (e.Data != null)
            {
                string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                txtMdl.Text = strFiles[0];
            }
        }

        private void txtMdl_s_Drop(object sender, DragEventArgs e)
        {
            if (e.Data != null)
            {
                string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                txtMdl_s.Text = strFiles[0];
            }
        }

        private void txtMdl_d_Drop(object sender, DragEventArgs e)
        {
            if (e.Data != null)
            {
                string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                txtMdl_d.Text = strFiles[0];
            }
        }

        private void txtVae_Drop(object sender, DragEventArgs e)
        {
            if (e.Data != null)
            {
                string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                txtVae.Text = strFiles[0];
            }
        }

        private void txtEmb_Drop(object sender, DragEventArgs e)
        {
            if (e.Data != null)
            {
                string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                txtEmb.Text = strFiles[0];
            }
        }

        private void txtMdl_l_Drop(object sender, DragEventArgs e)
        {
            if (e.Data != null)
            {
                string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                txtMdl_l.Text = strFiles[0];
            }
        }

        private void txtClp_Drop(object sender, DragEventArgs e)
        {
            if (e.Data != null)
            {
                string[] strFiles = (string[])e.Data.GetData(DataFormats.FileDrop);
                txtClp.Text = strFiles[0];
            }
        }

        private void txtModel_PreviewDragOver(object sender, DragEventArgs e)
        {
            e.Handled = true;
        }

        private async Task<MessageBoxResult> MessageBox_Show(string Message, string Title, MessageBoxButton MsgBoxButton, MessageBoxImage MsgBoxImage)
        {
            var msgbox = new MessageBoxLDG(Title, Message, MsgBoxButton, MsgBoxImage);
            var rtn = await dialogHost.ShowDialog(msgbox);
            if (rtn == null) return MessageBoxResult.Cancel;
            return (MessageBoxResult)rtn;
        }

        private void cboPrm_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            SetPrimaryColors();
        }

        private void SetBaseColors()
        {
            PaletteHelper palette = new PaletteHelper();
            Theme theme = palette.GetTheme();
            if (chkMod.IsChecked.Value)
            {
                theme.SetBaseTheme(BaseTheme.Light);
            }
            else
            {
                theme.SetBaseTheme(BaseTheme.Dark);
            }
            palette.SetTheme(theme);
        }

        private void SetPrimaryColors()
        {
            PaletteHelper palette = new PaletteHelper();
            Theme theme = palette.GetTheme();
            switch (cboPrm.SelectedIndex)
            {
                case 0:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Amber]);
                    break;
                case 1:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Blue]);
                    break;
                case 2:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.BlueGrey]);
                    break;
                case 3:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Brown]);
                    break;
                case 4:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Cyan]);
                    break;
                case 5:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.DeepOrange]);
                    break;
                case 6:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.DeepPurple]);
                    break;
                case 7:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Green]);
                    break;
                case 8:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Grey]);
                    break;
                case 9:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Indigo]);
                    break;
                case 10:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.LightBlue]);
                    break;
                case 11:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.LightGreen]);
                    break;
                case 12:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Lime]);
                    break;
                case 13:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Orange]);
                    break;
                case 14:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Pink]);
                    break;
                case 15:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Purple]);
                    break;
                case 16:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Red]);
                    break;
                case 17:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Teal]);
                    break;
                case 18:
                    theme.SetPrimaryColor(SwatchHelper.Lookup[(MaterialDesignColor)PrimaryColor.Yellow]);
                    break;
            }
            palette.SetTheme(theme);
        }
        private async void btnColDel_Click(object sender, RoutedEventArgs e)
        {
            if (await MessageBox_Show("Delete Message. Are you sure?", this.Title, MessageBoxButton.YesNo, MessageBoxImage.Question) == MessageBoxResult.Yes)
            {
                if (dtCht.Rows[dvwMsg.SelectedIndex].RowState != DataRowState.Deleted)
                {
                    long lngSq = long.Parse(dtCht.Rows[dvwMsg.SelectedIndex][2].ToString());
                    chtHis.Messages.Remove(chtHis.Messages[dvwMsg.SelectedIndex + 1]);
                    dtCht.Rows[dvwMsg.SelectedIndex].Delete();
                    dtCht.AcceptChanges();
                    //ExcSql($"update ch{cboCht.SelectedValue} set flg=1 where sq={lngSq}");
                    ExcSql($"delete from ch{cboCht.SelectedValue} where sq={lngSq}"); //物理削除
                }
            }
        }

        private async void recognizer1_SpeechRecognized(object sender, SpeechRecognizedEventArgs e) 
        {
            try
            {
                if (e.Result.Confidence > 0.89)
                {
                    Debug.WriteLine($"recognizer1,booMic={booMic},chkMic.IsEnabled={chkMic.IsEnabled}");
                    if (!booMic && chkMic.IsEnabled && !Wt)
                    {
                        chkMic.IsChecked = true;
                        chkMic_Change();
                        if (booGrf && !booFgf) //一度でも会話していたら挨拶しない
                        {
                            await Chat(strGrk);
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error32: code={ex.HResult},msg={ex.Message}");
            }
        }
        private void recognizer2_SpeechRecognized(object sender, SpeechRecognizedEventArgs e)
        {
            try
            {
                if (e.Result.Confidence > 0.89)
                {
                    Debug.WriteLine($"recognizer2,booMic={booMic},chkMic.IsEnabled={chkMic.IsEnabled}");
                    if (booMic && chkMic.IsEnabled && !Wt) 
                    {
                        chkMic.IsChecked = false;
                        chkMic_Change();
                    }
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error33: code={ex.HResult},msg={ex.Message}");
            }
        }
        private bool CheckAslp(string strMsg)
        {
            bool booRtn = false;
            if (Regex.IsMatch(strMsg, AsleepWord)) booRtn = true;
            return booRtn;
        }
        private void recognizer3_SpeechRecognized(object sender, SpeechRecognizedEventArgs e)
        {
            try
            {
                if (e.Result.Confidence > 0.89)
                {
                    Debug.WriteLine("recognizer3");
                    if (!booMic && !Wt) //マイクオフの時に終了を受け付ける
                    {
                        System.Windows.Application.Current.Shutdown();
                    }
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine($"Error34: code={ex.HResult},msg={ex.Message}");
            }
        }

        private string EDB(string strMsg) 
        {
            string strRtn = strMsg;
            if (booBnf)
            {
                string[] strBnk = strBan.Split(",");
                if (strBnk.Length > 1)
                {
                    for (int i = 0; i < strBnk.Length; i+=2)
                    {
                        if(i < strBnk.Length - 1)
                            strRtn = strRtn.Replace(strBnk[i], strBnk[i+1]);
                    }
                }
            }
            return strRtn;
        }

        private void txtFrp_GotFocus(object sender, RoutedEventArgs e)
        {
            txtFrp.SelectAll();
        }

        private void chkSpk_Click(object sender, RoutedEventArgs e)
        {
            chkSpk_Change();
        }

        private void txtMxt_GotFocus(object sender, RoutedEventArgs e)
        {
            txtMxt.SelectAll();
        }

        private void txtHwt_GotFocus(object sender, RoutedEventArgs e)
        {
            txtHwt.SelectAll();
        }

        private void dvwMsg_KeyDown(object sender, System.Windows.Input.KeyEventArgs e)
        {
            if (!e.IsRepeat
                & Keyboard.GetKeyStates(Key.LeftCtrl).HasFlag(KeyStates.Down)
                & Keyboard.GetKeyStates(Key.C).HasFlag(KeyStates.Down))
            {
                if(dvwMsg.SelectedItem != null)
                {
                    Clipboard.SetText(((TextBlock)dvwMsg.Columns[1].GetCellContent(dvwMsg.SelectedItem)).Text);
                }
            }
        }

    }
}